#include <stdio.h>
#include <ctype.h>
#include <math.h>

#define PI    3.14159265358979323846

#define bool  unsigned char
#define TRUE  1
#define FALSE 0

int  main(void)
{
   double  r, f, u;
   char  wahl;
   bool  erlaubte_wahl=TRUE;
   
   printf("\n\nFlaeche, Umfang und Radius eines Kreises\n"
          "========================================\n\n"
          "Du kannst waehlen, was du eingeben moechtest.\n"
          "Ich berechne Dir dann die 2 fehlenden Groessen.\n\n"
          "    Flaeche eingeben:    f\n"
          "    Umfang eingeben:     u\n"
          "    Radius eingeben:     r\n\n"
          "Deine Wahl? ");
   
   switch (wahl=tolower(getchar())) {
      case 'f':
         printf("\n\nFlaeche? ");
         scanf("%lf", &f);
         r = sqrt(f/PI);
         u = 2*r*PI;
         break;
      case 'u':
         printf("\n\nUmfang? ");
         scanf("%lf", &u);
         r = u/(2*PI);
         f = r*r*PI;
         break;
      case 'r':
         printf("\n\nRadius? ");
         scanf("%lf", &r);
         f = r*r*PI;
         u = 2*r*PI;
         break;
      default:
         erlaubte_wahl=FALSE;
         break;
   }
   if (erlaubte_wahl) {
      printf("\n\n");
      printf("...... Radius  = %.2lf\n", r);      
      printf("...... Flaeche = %.2lf\n", f);      
      printf("...... Umfang  = %.2lf\n", u);      
   } else
      printf("\n\a......'%c' ist keine erlaubte Wahl\n", wahl);
   return(0);
}
