#include <stdio.h>

int  main(void)
{
   unsigned long int  ab, bis,
                      i, j,
                      zahl;
   int  hamming_zahl;  /* Boole'sche Variable */

   printf("HAMMING-Folge\n");
   printf("=============\n\n");
   printf("Hamming-Zahlen sind Zahlen, die keine anderen Primteiler als\n");
   printf("   2, 3 oder 5 haben.\n");
   printf("Dieses Programm gibt Ihnen die Hamming-Zahlen fuer einen\n");
   printf("Bereich aus, dessen obere und untere Grenze Sie waehlen koennen\n\n");

   printf("Untere Bereichsgrenze: ");
   scanf("%ld", &ab); fflush(stdin);
   printf("Obere Bereichsgrenze: ");
   scanf("%ld", &bis); fflush(stdin);
   printf("\n");

   for (i=ab ; i<=bis ; i++) {
      hamming_zahl = 0;
      zahl = i;
      for (j=2 ; j<=5 ; j++)
         for ( ; zahl%j==0 ; ) {  /* Solange, wie zahl durch j teilbar ist */
            hamming_zahl=1;
            zahl /= j;
         }
      if (hamming_zahl && zahl==1)
         printf("%7ld ", i);
   }
   return(0);
}
