#include <stdio.h>
#include <time.h>

#define RAND_MAX  0x7fffffff
#define rand()   (z=z*1103515245+12345, z&RAND_MAX)
#define srand(s)  z=s

unsigned long int z=1;

int  main(void)
{
   long int  i, wieoft, erfolg;
      float  x, erfolgs_grenze, zaehl, gesamt=0;

   printf("Durchschnittl. Bohrversuche bis man fuendig wird\n");
   printf("================================================\n\n");
   printf("Die Wahrscheinlichkeit, dass man bei einer Oelbohrung fuendig wird,\n");
   printf("ist x %%\n\n");
   printf("Dieses Programm ermittelt ueber Simulation die durchschnittl.\n");
   printf("notwendige Anzahl von Bohrungen, um  mind. einmal fndig zu werden.\n\n");

   printf("Wahrscheinlichkeit (in Prozent) fuer eine erfolgreiche Bohrung: ");
   scanf("%f", &x);
   printf("Wieviele Simulationen durchfuehren: ");
   scanf("%ld", &wieoft);

   srand(time(NULL));
   erfolgs_grenze=RAND_MAX*x/100; /* bildet den Wahrscheinlichkeitsraum
                                     von 100 % auf den Bereich [0,RAND_MAX] ab */

   for (i=1 ; i<=wieoft ; i++) {
       zaehl=erfolg=0;
       while (!erfolg) {
          zaehl++;
          if (rand()<erfolgs_grenze)
             erfolg++;
       }
       gesamt += zaehl;
   }
   printf("\n\nDurchschnittl. benoetigt man %.2f Bohrungen, "
          "um einmal fuendig zu werden\n", gesamt/wieoft);
   return(0);
}
