#include <time.h>
#include <stdio.h>
#include <math.h>

int  main(void)
{
   double   wert, i;
   clock_t  start, ende, eln_zeit;

   start = clock();
   for (i=1 ; i<=10000000 ; i++)
      wert = exp(2 * log(i));   /* entspricht:  i hoch 2 */
   eln_zeit = clock();
   for (i=1 ; i<=10000000 ; i++)
      wert = pow(i, 2);
   ende = clock();

   printf("Berechnen von i hoch 2 (i=1,.,10000000) mit e/ln: %10.3lf Sek\n",
           (eln_zeit-start)/(double)CLOCKS_PER_SEC);
   printf("Berechnen von i hoch 2 (i=1,.,10000000) mit pow:  %10.3lf Sek\n",
           (ende-eln_zeit)/(double)CLOCKS_PER_SEC);
   printf("Gesamte vom Programm verbrauchte Zeit:            %10.3lf Sek\n",
           (ende-start)/(double)CLOCKS_PER_SEC);
   return(0);
}
