#include <stdio.h>
#include <graphics.h>
#include <stdlib.h>
#include <time.h>

#define SW   0.01

int main( int argc, char *argv[] )
{
   double   a, b, c, d,
	    x, xfmin, xfmax, y, yfmin, yfmax,
            xb, yb, xfaktor, yfaktor, xbnull, ybnull;
    srand(time(NULL));
       /*------- Eingaben des Benutzers ---------------------------------------*/
    printf("Graphische Darstellung der Funktion\n"
           "          3     2\n"
           "   y =  ax  + bx  + cx + d\n\n");
    printf("a? ");  scanf("%lf", &a);
    printf("b? ");  scanf("%lf", &b);
    printf("c? ");  scanf("%lf", &c);
    printf("d? ");  scanf("%lf", &d);
    printf("\n\nxmin? ");  scanf("%lf", &xfmin);
    printf("xmax? ");      scanf("%lf", &xfmax);
       /*------- Funktion berechnen, um yfmin und yfmax zu ermitteln ----------*/
    yfmin = yfmax = a*xfmin*xfmin*xfmin + b*xfmin*xfmin + c*xfmin + d;
    for (x=xfmin+SW ; x<=xfmax ; x+=SW) {
       y = a*x*x*x + b*x*x + c*x + d;
       if (y>yfmax)
          yfmax=y;
       if (y<yfmin)
          yfmin=y;
    }
       /*------- Massstab-Faktoren berechnen ----------------------------------*/
    initgraph( 640, 480 );
    xfaktor = getmaxx() / (xfmax-xfmin);
    yfaktor = getmaxy() / (yfmax-yfmin);
       /*------- Ausgabe der Koordinaten-Achse --------------------------------*/
    xbnull = -xfmin * xfaktor;
    ybnull =  yfmax * yfaktor;
    line(0, (int)ybnull, (int)xbnull, (int)ybnull);
    line((int)xbnull, 0, (int)xbnull, (int)ybnull);
    line(getmaxx(), (int)ybnull, (int)xbnull, (int)ybnull);
    line((int)xbnull, getmaxy(), (int)xbnull, (int)ybnull);
       /*------- Koordinaten-Beschriftung -------------------------------------*/
    outtextxy(0, (int)(ybnull-10), getmaxx(), getmaxy(), "|%-10.1lf", xfmin );
    outtextxy(getmaxx()-90, (int)(ybnull-10), getmaxx(), getmaxy(), "%10.1lf|", xfmax );
    outtextxy((int)(xbnull-3), 0, getmaxx(), getmaxy(),"-%-10.1lf", yfmax );
    outtextxy((int)(xbnull-3), getmaxy()-10, getmaxx(), getmaxy(), "-%-10.1lf", yfmin );
       /*------- Ausgabe der Funktion -----------------------------------------*/
    for (x=xfmin ; x<=xfmax ; x+=SW) {
       y = a*x*x*x + b*x*x + c*x + d;
       xb = (x - xfmin) * xfaktor;
       yb = (yfmax -y) * yfaktor;
       putpixel((int)xb, (int)yb, BLACK );
    }
    getch();
    closegraph();
    return(0);
}
