#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <graphics.h>

int  main( int argc, char *argv[] )
{
   float  p;  /* Einzulesende Wahrscheinlichkeit */
   int grenze,
       x, y, x_max, y_max,
       noch_oel=1; /* Boole'sche Var.: 1, solange Oel da, sonst dann 0 */
   int farbe;

    srand(time(NULL)); /* Zufallszahlen-Generator initialisieren */
    
    /*--- Graphik einschalten */
    initgraph( 640, 480 );
    
    /*--- Wahrscheinlichkeit fuer Oel-Eindringen einlesen */
    p = getdouble("Wahrscheinlichkeit fuer Eindringen des Oels ? " );
    grenze = (int)(RAND_MAX*p);

    /*--- Graphikbildschirm loeschen und maximal moegl. Koordinaten ermitteln */
    cleardevice( LIGHTGRAY );
    x_max = getmaxx();
    y_max = getmaxy();

    /*--- Eindringen des Oels am Bildschirm simulieren */
    for (x=x_max/4 ; x<=x_max*3/4 ; x++)
       if ((x+1)%2==0)
          putpixel(x,1,BLUE);
    for (y=1 ; y<y_max-1 && noch_oel ; y++) {
       noch_oel=0;
       for (x=0 ; x<x_max-1 ; x++) {
          farbe = getpixel(x,y);
          if (farbe==BLUE || farbe==RED) {
             noch_oel=1;
             if (x-1>=0 && rand()<=grenze)
                putpixel(x-1,y+1,BLUE);
             if (x+1<=x_max && rand()<=grenze)
                putpixel(x+1,y+1,RED);
          }
       }
       if ( kbhit() )
          break;
    }
    getch();
    closegraph();
    return(0);
}
