#include <graphics.h>
#include <ctype.h>
#include <stdlib.h>
#include <time.h>

int  main( int argc, char *argv[] )
{
   int  xmax, ymax, xmitte, ymitte, radius,
        xunten, xoben, yunten, yoben, x, y, farbe;
   long int  n, z, innen;
   char string[1000];

   srand(time(NULL));
   initgraph( 640, 480 );
   z = innen = 0;
   xmax = getmaxx();
   ymax = getmaxy();

   sprintf( string, "Berechnung von PI ber Regentropfen\n"
              "===================================\n\n"
              "Dieses Programm malt zunaechst einen Kreis am Bildschirm.\n"
              "Danach simuliert es einen Regen und zaehlt dabei alle Tropfen,\n"
              "die im Kreis niedergehen.\n\n"
              "Diese im Kreis gefallenen Tropfen teilt es dann durch die\n"
              "Gesamtzahl der Tropfen und multipliziert dieses Ergebnis mit 4.\n"
              "Die so ermittelte Zahl sollte dann eine Naeherung von PI sein.\n"
              "Je mehr Regentropfen Sie fallen lassen, umso naeher sollte die\n"
              "so ermittelte Zahl an der wirklichen Zahl PI liegen.\n\n\n"
              "Weiter mit einer beliebiger Taste........");
   outtextxy( 10, 10, xmax, ymax, string );
   getch();

    /*------ Graphikmodus einschalten und Variablen initialisieren -------*/
   do {
      z = innen = 0;
         /*------ Gesamtzahl der Regentropfen einlesen ------------------------*/
      n = getint("Wieviele Regentropfen ?" );
      clearviewport( BLACK );
         /*------ Rechteck- und Kreis-Groessen ermitteln ----------------------*/
      xmitte = xmax/2;   ymitte = ymax/2;
      radius = ymitte-1;
      xunten = xmitte-radius; yunten = ymitte-radius;
      xoben  = xmitte+radius; yoben  = ymitte+radius;
         /*------ Rechteck und Kreis am Bildschirm malen ----------------------*/
      setfillstyle( SOLID_FILL, RED );
      bar( xunten, yunten, xoben, yoben );
      setfillstyle( SOLID_FILL, BLUE );
      setcolor( BLUE );
      fillellipse( xmitte, ymitte, radius, radius);
      setcolor( BLACK );
         /*------ Simulation des Regens ---------------------------------------*/
      while ( ++z <= n ) {
         x = xunten+rand()%(xoben-xunten+1);
         y = yunten+rand()%(yoben-yunten+1);
         farbe = getpixel(x,y);
         if ( farbe==BLUE || farbe==GREEN ) {
            innen++;
	    putpixel( x, y, GREEN );
         } else
            putpixel( x, y, WHITE );
         if ( z%1000==0 || z==n ) { /* Bisherige PI-Naeherung alle 1000 Tropfen */
            setviewport( xmitte+radius,0, xmax, 50 );
            clearviewport( WHITE );
            outtextxy(xmitte+radius+5, 10, xmax, ymax, "%ld:", z);
            outtextxy(xmitte+radius+10,30, xmax, ymax, "%.5f", innen*4.0/z);
            setviewport(0,0,xmax,ymax);
         }
      }
         /*------ Zurueck zum Textmodus und Ergebnis ausgeben ----------------*/
      sprintf( string, "Bei %ld Regentropfen fielen\n"
                       "%ld Tropfen innerhalb des Kreises\n\n"
                       "Daraus ergibt sich eine Nherung fuer PI von ...%.6f..."
                       "\n\nWollen Sie noch einmal simulieren [j/n] ?",
                       n, innen, innen*4.0/n);
         /*------ Einlesen, ob eine weitere Simulation gewuenscht -------------*/
   } while ( tolower(getcharacter(string)) == 'j' );
   closegraph();
   return(0);
}
