#include <graphics.h>
#include <stdlib.h>
#include <time.h>

int  main( int argc, char *argv[] )
{
   int maxx, maxy,
       startx, starty, x, y, altx, alty;

   /*---- Graphik initialisieren -------------------------------------------*/
   initgraph( 640, 480 );
   setcolor( WHITE );
   setfillstyle( SOLID_FILL, BLACK );
   bar3d( 0, 0, maxx=getmaxx(), maxy=getmaxy(), 0 );

   /*---- Maus initialisieren ----------------------------------------------*/
   mouse_setwindow(1, 1, maxx-1, maxy-1);

   do {
      /*---- linke Maustaste bewirkt Zeichnen eines Quadrats ---------------*/
      if ( mouse_left() ) {
         setwritemode( XOR_PUT );
         setlinestyle( DASHED_LINE, 1 );
         setcolor( WHITE );
         mouse_getpos( &startx, &starty );
         altx = startx;
         alty = starty;
	 rectangle( startx, starty, altx, alty );
         mouse_setcursor( blankCursor );
         while ( mouse_left() ) {
            mouse_getpos( &x, &y );
            if ( x!=altx || y!=alty ) {
               rectangle( startx, starty, x, y );
               rectangle( startx, starty, altx, alty );
               altx = x;
               alty = y;
            }
         }
         rectangle( startx, starty, altx, alty );
         setlinestyle( SOLID_LINE, 1 );
	 setwritemode( COPY_PUT );
         rectangle( startx, starty, x, y );
      }

      mouse_setcursor( arrowCursor );
      /*---- rechte Maustaste bewirkt Fuellen eines Quadrats ---------------*/
      if ( mouse_right() ) {
         mouse_setcursor( blankCursor );
         setfillstyle(SOLID_FILL, rand()%getmaxcolor());
         bar3d( startx, starty, x, y, 0 );
         while ( mouse_right() )
            ;
      }
   } while (!kbhit());
   getch();
   closegraph();
   return 0;
}
