#include <stdlib.h>
#include <time.h>
#include <graphics.h>

#define EINH  5

int  main( int argc, char *argv[] )
{
   int x, y, alty, distanz;
   void *puffer;
    srand(time(NULL));  /* Zufallsgenerator initialisieren */

    initgraph( 640, 480 );
    cleardevice( BLACK );
    x = getmaxx()/2;
    y = getmaxy()/2;
    setcolor(getmaxcolor());
        /* Textstil festlegen */
    settextstyle( "Times", 48 );
        /* Sandmaennchen in die Mitte malen */
    moveto(x,y); linerel( 2*EINH, 2*EINH); linerel(-EINH, EINH);  /* Bein vorne */
    moveto(x,y); linerel(-2*EINH, 2*EINH); linerel(-EINH, -EINH); /* Bein hinten*/
    moveto(x,y); linerel(0, -2*EINH);                             /* Koerper    */
    moveto(x,y-EINH); linerel(-EINH,0); linerel(-EINH,EINH/2);    /* Arm hinten */
    moveto(x,y-EINH); linerel(EINH,EINH); linerel(EINH,-EINH);    /* Arm vorne  */
    circle(x,y-2*EINH-EINH/2,EINH/2);                             /* Kopf       */
       /* Bild vom Sandmaennchen in internen Puffer hinterlegen */
    getimage( x-3*EINH, y-3*EINH, x+3*EINH, y+3*EINH, &puffer );
       /* Sandmaennchen wandert quer ber den Bildschirm */
    while (!kbhit()) {
       cleardevice( BLACK );
       y=rand()%getmaxy();
       outtextxy( 0, (y>200)?10:350, getmaxx(), getmaxy(), "Ich bin Kaffeetrinken");
       putimage(0, y-3*EINH, puffer, XOR_PUT);
       distanz=EINH/9+1;
       for (x=3*EINH+distanz ; x<=getmaxx() ; x+=distanz ) {
          alty=y;
          y += rand()%7-3;
            /* Neues Sandmaennchen malen und .... */
          putimage(x-3*EINH, y-3*EINH, puffer, XOR_PUT);
            /* altes Sandmaennchen loeschen */
          putimage(x-3*EINH-distanz, alty-3*EINH, puffer, XOR_PUT);
            /* Sand streuen */
          putpixel(x-3*EINH-distanz, alty+3*EINH, YELLOW);
          if ( kbhit() )
             break;
          delay( 1 );
       }
    }
    closegraph();
    return(0);
}
