#include   <stdio.h>
#include   <stdarg.h>

/*------- fehl_meld --------------------------------------------*/
void  fehl_meld(int kennung, const char *fmt, ...)
{
   va_list  az;   
   
   va_start(az, fmt);

   switch (kennung) {
      case 0:
         vprintf(fmt, az);
         printf("\n");
         break;
      case 1:
         printf("Warnung: ");
         vprintf(fmt, az);
         printf("\n");
         break;
      case 2:
         printf("Fehler: ");
         vprintf(fmt, az);
         printf("\n");
         break;
      default:
         fehl_meld(2, "Falscher Aufruf von fehler_meld....", az);
         break;
   }
         
   va_end(az);
   return;
}

/*------- main --------------------------------------------------*/
int  main(void)
{
   double wert = 3.0/7;
   int    zahl = 125;
       
   fehl_meld(0, "%d * %d = %d", 2, 3, 2*3);
   fehl_meld(0, "%s ist %.6lf", "Drei geteilt durch sieben", wert);
   fehl_meld(0, "Hans ist %d alt", 34);
   fehl_meld(1, "Illegale Eingabe `%d....", zahl);
   fehl_meld(2, "Du musst Zahlen aus Intervall [%d, %d] eingeben", 5, 10);
   fehl_meld(3, "%d mal %.3lf = %.3lf", zahl, wert, zahl*wert);
   return(0);
}

