/*--------- Definitionen fuer boole'sche Variablen -----------------------*/
#define  boolean  unsigned char
#define  TRUE     1
#define  FALSE    0

/*-------------------------------------------------------------------------*/
extern boolean  einaus_init(char *erstes_zeichen);
/*---------------------------------------------------------------------------
            -- initialisiert Bildschirm fuer die Eingabe des Bandinhalts
               und liest dann das erste Eingabezeichen.                    */

/*-------------------------------------------------------------------------*/
extern int  bildschirm_bewege_kopf(int alt_pos, int neu_pos, 
                                   int ausgab_zeich, char *eingab_zeich,
                                   int alt_zustand, int neu_zustand);
/*---------------------------------------------------------------------------
            -- simuliert die Turingmaschine am Bildschirm, indem sie zunaechst
               das 'ausgab_zeich' an 'alt_pos' ausgibt und dann den 
               Lese-/Schreibkopf von 'alt_pos' auf 'neupos' bewegt, wo sie
               dann das naechste Eingabezeichen liest und ueber 'eingab_zeich'
               an den Aufrufer zurueckliefert.
               Ueber 'alt_zustand' wird aktueller Zustand der Turingmaschine
               und ueber 'neu_zustand' neuer Zustand der Turingmaschine zur
               Anzeige am Bildschirm uebergeben.                             */
