/*----------- Konstantendefinitionen ---------------------------------*/
#define  OK      1
#define  FERTIG  2
#define  FEHLER  3
#define  boolean unsigned char
#define  TRUE   1
#define  FALSE  0

/*-------------------------------------------------------------------------*/
extern boolean  erlaubtes_zeichen(char zeichen);
/*---------------------------------------------------------------------------
            -- liefert zurueck, ob es sich bei 'zeichen' um ein erlaubtes
               Zeichen fuer die Turing-Maschine handelt.                   */
 
/*-------------------------------------------------------------------------*/
extern int  turing_regeln(void);
/*---------------------------------------------------------------------------
            -- simuliert die Turing-Maschine.
               Zur Simulation auf dem Bildschirm ruft diese Funktion eine 
               Routine aus dem Modul 'bildschi.c' auf. 
               Der Rueckgabewert (OK, FERTIG, FEHLER) zeigt an, ob ein Zeichen
               von Turingmaschine akzeptiert wurde, oder ob die Turingmaschine
               nun stoppt oder ob ein unerlaubtes Zeichen auf dem Eingabeband
               gelesen wurde.                                                */
