#include  <stdio.h>

long  bcd_umwandel(long  dual);

int  main(void)
{
    long   i,  binaer,  bcd_zahl;

    do {
       printf("\nGeben Sie eine positive ganze Zahl (0-99999999) ein: ");
       scanf("%ld", &binaer);
       if (binaer<0 || binaer>99999999)  {
          printf("\n\nNur Zahlen aus dem Intervall 0 bis 99999999 erlaubt !");
          printf("\n......Wiederholen Sie Ihre Eingabe !\n\n");
       }
    } while (binaer<0 || binaer>99999999);

    printf("\n\nDualdarstellung von %ld :\n",binaer);
    for (i=31; i>=0; i--)
       printf("%ld", (binaer>>i) & 1);

    printf("\n\nBCD-Darstellung von %ld :\n",binaer);
    bcd_zahl = bcd_umwandel(binaer);
    for (i=31 ; i>=0; i--)
       printf("%ld%s", (bcd_zahl>>i) & 1, (i%4==0) ? " ": "");
    printf("\n");
    return(0);
}

long  bcd_umwandel(long  dual)
{
    long  bcd_code = dual%10;

    if (dual/=10)
       return(bcd_code+(bcd_umwandel(dual)<<4));
    else
       return(bcd_code);
}
