#include  <stdio.h>
#include  <stdlib.h>
#include  <time.h>

const float mwst_satz = 0.16;

void mwst(int zeilen, int spalten, double array[*][*]); 

int main(void)
{
   int  i, j, z, s;

   srand(time(NULL));   

   z = rand()%10+1;
   s = rand()%3+1;
  
   double matrix[z][s];  // Variables Array

   for (i=0; i<z; i++)
      for (j=0; j<s; j++)
         matrix[i][j] = rand()%100000/100.0;
   mwst( z, s, matrix );

   return 0;
}

void mwst(int zeilen, int spalten, double array[zeilen][spalten])
{
   double netto[zeilen][spalten],  // Variable Arrays
          mw[zeilen][spalten];     //  ............
   int i, j;

   for (i=0; i<zeilen; i++)
      for (j=0; j<spalten; j++) {
         netto[i][j] = array[i][j] / (1+mwst_satz) * 1;
         mw[i][j] = array[i][j] / (1+mwst_satz) * mwst_satz;
      } 
   for (i=0; i<zeilen; i++) {
      for (j=0; j<spalten; j++)
         printf("%7.2f + %6.2f = %6.2f |", netto[i][j], mw[i][j], array[i][j]);
      printf("\n");
   }
}
