#include  <stdio.h>

/*------ 1. Realisierung von strcpy mit Zeigern ----------------------------*/
char *strcpy1(char *ziel, const char *quelle)
{
   char  *rueckgabe = ziel;
   while ( (*ziel = *quelle) ) {
      ziel++;
      quelle++;
   }
   return(rueckgabe);
}

/*------ 2. Realisierung von strcpy mit Zeigern ----------------------------*/
char *strcpy2(char *ziel, const char *quelle)
{
   char  *rueckgabe = ziel;
   while ( (*ziel++ = *quelle++) )  /* entspricht folg. Anweisungsfolge: */
      ;                             /*    *ziel = *quelle                */
                                    /*    *ziel != 0     (Vergleich)     */
                                    /*    ziel++; quelle++;              */
   return(rueckgabe);
}

int  main(void)
{
   char  *gruss = "Hallo, wie gehts";
   char  gruss1[100], gruss2[100];
   
   strcpy1(gruss1, gruss);
   printf("%s\n", gruss1);
   
   strcpy2(gruss2, gruss);
   printf("%s\n", gruss2);
   
   return(0);
}
