#include  <stdio.h>
#include  <stdlib.h>
#include  <time.h>

#define ARRAY_GROESSE  1024
#define ITERATIONEN    1000000L

/*--------- main -----------------------------------------------------------*/
int  main(void)
{
   long     i, j, zaehl=0;
   float    fzahlen[ARRAY_GROESSE];
   clock_t  zeit1, zeit2;

   srand(time(NULL));

      /* Array fzahlen mit zuflligen Gleitpunktzahlen aus
         den Intervall [0,500] fllen                      */
   for (i=0 ; i<ARRAY_GROESSE ; i++)
      fzahlen[i] = (rand()%500)/(float)(rand()%500+1);

   zeit1 = clock();
   for (i=1 ; i<=ITERATIONEN; i++) {
        /* Suchen einer zufaellig ausgewaehlten Zahl im Array fzahlen */
      float z = fzahlen[rand()%ARRAY_GROESSE];
      for (j=0; j<ARRAY_GROESSE; j++) {
          zaehl++;
          if (z == fzahlen[j])
             break;
      }
   }
   zeit2 = clock();

   printf("--------------------------------------------------------\n");
   printf("Vergleiche insgesamt:      %ld\n", zaehl);
   printf("Vergleiche durchschnittl.: %.2f\n", (float)zaehl/ITERATIONEN);
   printf("Gebrauchte Zeit:           %.2f Sek.\n",
          (zeit2-zeit1) / (float)CLOCKS_PER_SEC);
   printf("--------------------------------------------------------\n");
   return(0);
}
