#include  <stdio.h>

#define  LAENGE   80    /* maximale Laenge der eingegebenen Zeichenkette  */

void  lies_zeile(char *string);
char *strstr(char *kett1, const char *kett2);

int  main(void)
{
    char    zeichenkette[LAENGE+1],  such_kette[LAENGE+1], *wo;
    int     i;
    
    printf("\nGeben Sie eine Zeichenkette (max. 80 Zeichen) ein:\n");

    lies_zeile(zeichenkette);      /* Einlesen einer Zeichenkette in einer  */
                                   /*  Zeile in das Array   zeichenkette    */

    printf("\nGeben Sie den zu suchenden Text (max. 80 Zeichen) ein:\n");

    lies_zeile(such_kette);        /* Einlesen einer Zeichenkette in einer  */
                                   /*  Zeile in das Array  such_kette       */
    wo = strstr(zeichenkette, such_kette);
    printf("\nDer Text\n    %s\n", such_kette);
    if (wo != NULL) {
       printf("beginnt in der Zeichenkette\n");
       printf(" %s\n", zeichenkette);
       for (i=0 ; i<=wo-zeichenkette ; i++) /*  bis zur gefundenen Position   */
          printf(" ");                      /*   Leerzeichen ausgeben         */
       printf("^\n\n");           /* Ausgabe des Markierungszeichens ^    */
    } else
       printf("ist in der Zeichenkette\n   %s\nnicht enthalten\n", zeichenkette);
    return(0);
}

void  lies_zeile(char *string)
{
    int i=0;

    do  {                    /*  hier werden die Zeichen einzeln eingelesen  */
       string[i]=getchar();  /*  und zwar in das Array  string,              */
       i++;                  /*  bis 80 Zeichen oder RETURN (= \n-Zeichen)   */
    } while (string[i-1]!='\n'  &&  i<=LAENGE);    /*  eingegeben wurde      */
  
    string[i-1]='\0';   /*  Stringende kennzeichnen (\n ueberschreiben)      */
}

char *strstr(char *kett1, const char *kett2)
{
    int   i,  j,  k;

    for (i=0 ; kett1[i] != '\0' ; i++)  {
       for (j=i,k=0 ; kett2[k] != '\0'  &&  kett1[j] == kett2[k] ; j++,k++)
           ;
       if (kett2[k] == '\0')
           return(&kett1[i]);
    }
    return(NULL);
}
