#include  <stdio.h>
#include  <stdlib.h>
#include  <time.h>

int  main(void)
{
    long     i, b, n=0;
    double   *zahl=NULL, max=0;
    clock_t  stoppuhr;
    
    printf("| %15s | %15s |\n", "Blockgroesse", "Gebrauchte Zeit");
    printf("+-----------------+-----------------+\n");
    for (b=1; b<=1024; b*=2 ) {
       max = n = 0;
       stoppuhr = clock();
       printf("| %15ld ", b);
       for (i=1; i<=10000000; i++) {
          if (n >= max) {
             max += b;
             zahl = (double *)realloc(zahl, max*sizeof(double));
          }
          n++;
       }
       printf("| %15.3f |\n", (clock()-stoppuhr)/(double)CLOCKS_PER_SEC);

       free(zahl); /* Freigeben des ganzen Speicherbereichs */
       zahl = NULL;
    }

    return(0);
}
