#include  <stdio.h>
#include  <string.h>

#define  MAX   100

unsigned  daten_einlesen(void);

struct {
   char      name[20];
   char      vorname[20];
   unsigned  stand       :2;
   unsigned  geschlecht  :1;
   unsigned  alter       :7;
   unsigned  kindzahl    :4;
   unsigned  religion    :2;
} daten[MAX];

/*--------------------------------------------------------------- main ----*/
int  main(void)
{
   unsigned  anzahl, i;

   anzahl = daten_einlesen();
   
   printf("\nDie betreffenden Personen sind:\n");
   for (i=0; i<anzahl; i++)
     if (daten[i].stand == 3 && daten[i].geschlecht == 1 &&
         daten[i].alter == 55 && daten [i].kindzahl == 3 &&
         daten[i].religion == 1)
        printf("%s %s\n", daten[i].name, daten[i].vorname);
   return(0);
}

/*----------------------------------------------------- daten_einlesen ----*/
unsigned  daten_einlesen(void)
{
   unsigned int  i=0, zahl;
   
   while (i<MAX) {
      printf("Name: ");
      fgets(daten[i].name, 20, stdin);
      daten[i].name[ strlen(daten[i].name)-1 ] = '\0'; /* \n am Ende entfernen*/
      if (strlen(daten[i].name) == 0)
         break;
      printf("Vorname: ");
       fgets(daten[i].vorname, 20, stdin);
       daten[i].vorname[ strlen(daten[i].vorname)-1 ] = '\0'; /* \n am Ende weg*/
      printf("Stand (ledig=0, verheiratet=1, geschieden=2, verwitwet=3): ");
       scanf("%d", &zahl);
       daten[i].stand = zahl & 0x3;
      printf("Geschlecht (maennlich=0, weiblich=1): ");
       scanf("%d", &zahl);
       daten[i].geschlecht = zahl & 0x1;
      printf("Alter: ");
       scanf("%d", &zahl);
       daten[i].alter = zahl & 0x7f;
      printf("Kinderzahl: ");
       scanf("%d", &zahl);
       daten[i].kindzahl = zahl & 0xf;
      printf("Religion (rk=0, ev=1, islam=2, andere=3): ");
       scanf("%d", &zahl);
       daten[i].religion = zahl & 0x3;
      getchar();
      i++;
   }
   return(i);
}
