#include  <stdio.h>

struct bruch {
    long  zaehler;
    long  nenner;
} zahl1, zahl2;

void  add(void);
void  sub(void);
void  mult(void);
void  divi(void);
void  kuerzen(void);
long  ggT(long n, long m);

void  (*(operation[]))(void) = { NULL, add, sub, mult, divi };

/*------------------------------------------------------ main -------------*/
int  main(void)
{
    int   wahl, zeich, i = 2;
    
    printf("1. Bruch: "); 
    scanf("%ld/%ld", &zahl1.zaehler, &zahl1.nenner);
    printf("2. Bruch: ");
    scanf("%ld/%ld", &zahl2.zaehler, &zahl2.nenner);
    
    while (1) {
       do {
          printf("\n\nDie beiden Brueche %ld/%ld und %ld/%ld\n",
                  zahl1.zaehler, zahl1.nenner, zahl2.zaehler, zahl2.nenner);
          printf(" 1 (addieren), 2 (subtrahieren),"
                 " 3 (multiplizieren), 4 (dividieren) ? ");
          scanf("%d", &wahl);
       } while (wahl<1 || wahl>4);
       if (wahl==1)       zeich = '+';
       else if (wahl==2)  zeich = '-';
       else if (wahl==3)  zeich = '*';
       else if (wahl==4)  zeich = '/';
       printf("....Ergebnis: %ld/%ld %c %ld/%ld = ",
               zahl1.zaehler, zahl1.nenner, zeich, zahl2.zaehler, zahl2.nenner);
       (*(operation[wahl]))();
       printf("%ld/%ld = ", zahl1.zaehler, zahl1.nenner);
       kuerzen();
       printf("%ld/%ld (gekuerzt)\n--------------------------------\n",
              zahl1.zaehler, zahl1.nenner);
       printf("%d. Bruch (0/0 = Ende): ", ++i);
       scanf("%ld/%ld", &zahl2.zaehler, &zahl2.nenner);
       if (zahl2.zaehler == 0 || zahl2.nenner == 0)
          break;
    } 
    return(0);
}

/*------------------------------------------------------- add -------------*/
void  add(void)
{
   zahl1.zaehler = zahl1.zaehler*zahl2.nenner + zahl2.zaehler*zahl1.nenner;
   zahl1.nenner  = zahl1.nenner * zahl2.nenner;
}

/*------------------------------------------------------- sub -------------*/
void  sub(void)
{
   zahl1.zaehler = zahl1.zaehler*zahl2.nenner - zahl2.zaehler*zahl1.nenner;
   zahl1.nenner  = zahl1.nenner * zahl2.nenner;
}

/*------------------------------------------------------ mult -------------*/
void  mult(void)
{
   zahl1.zaehler = zahl1.zaehler * zahl2.zaehler;
   zahl1.nenner  = zahl1.nenner * zahl2.nenner;
}

/*------------------------------------------------------ divi -------------*/
void  divi(void)
{
   zahl1.zaehler = zahl1.zaehler * zahl2.nenner;
   zahl1.nenner  = zahl1.nenner * zahl2.zaehler;
}

/*--------------------------------------------------- kuerzen -------------*/
void  kuerzen(void)
{
   long  ggTeiler = ggT(zahl1.zaehler, zahl1.nenner);

   zahl1.zaehler /= ggTeiler;
   zahl1.nenner  /= ggTeiler;
}

/*------------------------------------------------------- ggT -------------*/
long  ggT(long n, long m)
{
   return( (m==0) ? n : ggT(m, n%m) );
}
