#include  <stdio.h>
#include  <ctype.h>
#include  <string.h>

#define  MAX_ZEICHEN   1000

struct such_woerter {
    char   *wort;
    int    zaehl;
} schluesselwoerter[] = {
      {"auto",  0},    {"break", 0},    {"case", 0},     {"char", 0},
      {"const", 0},    {"continue", 0}, {"default", 0},  {"do", 0},
      {"double", 0},   {"else", 0},     {"enum", 0},     {"extern", 0},
      {"float", 0},    {"for", 0},      {"goto", 0},     {"if", 0},
      {"int", 0},      {"long", 0},     {"register", 0}, {"return", 0},
      {"short", 0},    {"signed", 0},   {"sizeof", 0},   {"static", 0},
      {"struct", 0},   {"switch", 0},   {"typedef", 0},  {"union", 0},
      {"unsigned", 0}, {"void", 0},     {"volatile", 0}, {"while", 0},
      {"inline", 0},   {"restrict", 0},
      {"_Bool", 0},    {"_Imaginary", 0}, {"_Complex", 0}
};

#define ANZAHL  sizeof(schluesselwoerter) / sizeof(schluesselwoerter[0])

/*----------------------------------- main -------------------------*/
int  main(void)
{
   char   *wort, satz[MAX_ZEICHEN], wort_trenn[] = "[](){}#<>.,;-+/% \t";
   int    i;

   while (fgets(satz, MAX_ZEICHEN, stdin) != NULL) {
      wort = strtok(satz, wort_trenn);
      while (wort != NULL) {
         for (i=0; i<ANZAHL; i++)
            if (!strcmp(wort, schluesselwoerter[i].wort))
               schluesselwoerter[i].zaehl++;
         wort = strtok(NULL, wort_trenn);
      }
   }
   printf("\n\nIn diesem Text sind folgende C-Schlsselwrter enthalten\n");
   for(i=0; i<ANZAHL; i++)
      if (schluesselwoerter[i].zaehl != 0)
         printf("%20s : %3d mal\n", schluesselwoerter[i].wort,
                                    schluesselwoerter[i].zaehl);
   return(0);
}
