#include  <stdio.h>
#include  <stdlib.h>

int  monat_tage[] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };

struct datum {
   int  tag;
   int  monat;
   int  jahr;
};

long  tage_diff(struct datum d1, struct datum d2);
long  tag_nr(struct datum d);
int   schaltjahr(int jahr);

/*-------------------------------------------------------------- main ------*/
int  main(void)
{
   struct datum  datum1, datum2;

   printf("          Tages-Differenz zwischen zwei Dati\n"
          "          ==================================\n\n");
   printf("1. Datum (tt.mm.jjjj): ");
   scanf("%d.%d.%d", &datum1.tag, &datum1.monat, &datum1.jahr);
   printf("2. Datum (tt.mm.jjjj): ");
   scanf("%d.%d.%d", &datum2.tag, &datum2.monat, &datum2.jahr);

   printf("\n..... Differenz: %ld Tage .....\n\n", tage_diff(datum1, datum2));
   return(0);
}

/*--------------------------------------------------------- tage_diff ------*/
long  tage_diff(struct datum d1, struct datum d2)
{
   return( labs(tag_nr(d2) - tag_nr(d1)) );
}

/*------------------------------------------------------------ tag_nr ------*/
long  tag_nr(struct datum d)
{
   long  i, tage = 0;
 
   for (i=1; i<d.jahr; i++)
      tage += 365 + schaltjahr(i);
   for (i=1; i<d.monat; i++) {
      tage += monat_tage[i-1];
      if (i==2 && schaltjahr(d.jahr))
         tage++;
   }
   tage += d.tag;
   return( tage );
}

/*-------------------------------------------------------- schaltjahr ------*/
int  schaltjahr(int jahr)
{
   return( (jahr%4 == 0 && jahr%100 != 0) || jahr%400 == 0 );
}
