#include  <stdio.h>
#include  <stdlib.h>
#include  <unistd.h>
#include  <sys/stat.h>
#include  <fcntl.h>

#define PUFF_GROESSE   512

int  main(int argc, char *argv[])
{
   int    fd1, fd2,
          n;
   char   puffer[PUFF_GROESSE];

   if (argc != 3) {
      fprintf(stderr, "usage: %s datei1 datei2\n", argv[0]);
      exit(1);
   }
   if ( (fd1 = open(argv[1], O_RDONLY)) == -1) {
      fprintf(stderr, "....kann Datei `%s' nicht zum Lesen oeffnen\n", argv[1]);
      exit(2);
   }
   if ( (fd2 = open(argv[2], O_WRONLY|O_APPEND)) == -1) {
      fprintf(stderr, "kann Datei `%s' nicht zum Schreiben oeffnen\n", argv[2]);
      exit(3);
   }
   while ( (n = read(fd1, puffer, PUFF_GROESSE)) > 0)
      if (write(fd2, puffer, n) != n) {
         fprintf(stderr, "...Fehler bei write\n");
         exit(4);
      }
   if (n == -1) {
      fprintf(stderr, "...Fehler bei read\n");
      exit(5);
   }
   return(0);
}
