#include  <stdio.h>
#include  <stdlib.h>

int  main(int argc, char *argv[])
{
   FILE                *fz;
   int                 i;
   unsigned long int   b, total=0;
      
   if (argc < 2) {
      printf("......Es muss mind. ein Dateiname angegeben sein\n");
      exit(1);
   }
   for (i=1 ; i<argc ; i++) {
      if ( (fz=fopen(argv[i], "rb")) == NULL) /*-- Oeffnen der i.ten Datei --*/
         printf("......Kann Datei `%s' nicht oeffnen\n", argv[i]);

      b=0;   /*---- Lesen und Zaehlen aller Bytes der i.ten Datei -----------*/
      while (fgetc(fz) != EOF)
         b++;
      total += b;
      if (ferror(fz))
         printf("Fehler beim Lesen aus Datei `%s'\n", argv[i]);

      fclose(fz); /*--- Schliessen der i.ten Datei --------------------------*/

      printf("%30s : %10lu\n", argv[i], b);
   }

   printf("-------------------------------------------\n");
   printf("%30s : %10lu\n", "Gesamt", total); /*-- Ausgabe gesamter Bytezahl --*/

   return(0);
}   
