#include  <stdio.h>
#include  <stdlib.h>
#include  <ctype.h>

int  main(int argc, char *argv[])
{
   FILE                 *fz;
   unsigned long  int   hexzahl;
   int                  zeich;
      
   if (argc != 2) {
      printf("....Es muss genau ein Dateiname auf der Kommandozeile angegeben sein\n");
      exit(1);
   }
   if ( (fz=fopen(argv[1], "r")) == NULL) {
      printf("....Kann Datei `%s' nicht eroeffnen", argv[1]);
      exit(2);
   }
   while ( (zeich=fgetc(fz)) != EOF) {
      if (isxdigit(zeich)) {
         ungetc(zeich, fz);
         fscanf(fz, "%lx", &hexzahl);
         printf("%lx=%lu\n", hexzahl, hexzahl);
      }
   }

   if (ferror(fz))
      fprintf(stderr, "Fehler beim Lesen aus Datei `%s'", argv[1]);
      
   fclose(fz);

   return(0);
}   
