#include  <stdio.h>
#include  <stdlib.h>
#include  <unistd.h>
#include  <sys/types.h>
#include  <sys/stat.h>
#include  <fcntl.h>

#define PUFF_GROESSE    512

static void ausgab(int fd);

int  main(int argc, char *argv[])
{
   int     i, fd;

   if (argc == 1) {   /* wenn keine Datei auf Kommandozeile angegeb. */
      ausgab(0);      /* dann von stdin lesen                        */
   } else {
      for (i=1 ; i<argc ; i++) {
         if ( (fd = open(argv[i], O_RDONLY)) == -1) {
            fprintf(stderr, "....kann `%s' nicht zum Lesen oeffnen\n", argv[i]);
            exit(1);
         }
         ausgab(fd);
         close(fd);
      }
   }
   return(0); 
}

static void ausgab(int fd)
{
   int     n;
   char    puffer[PUFF_GROESSE];

   while ( (n = read(fd, puffer, PUFF_GROESSE)) > 0)
      if (write(1, puffer, n) != n) {
         fprintf(stderr, "...Fehler bei write\n");
         exit(2);
      }

   if (n == -1) {
      fprintf(stderr, "...Fehler bei read\n");
      exit(3);
   }
}
