#include  <stdio.h>
#include  <string.h>
#include  <stdlib.h>
#include  <ctype.h>

int  main(void)
{
   FILE           *fz;                     /* Zeiger auf FILE-Struktur  */
   char           dateiname[100];              /*  Dateiname            */
   char           name[100], vorname[100], ort[100];           /* Daten */
   unsigned long  plz;                                         /*       */
   int            i, antw;                            /* Hilfsvariablen */
   
   fprintf(stderr, "In welche Datei (evtl. mit Pfad) "
                   "sollen Namen angehaengt werden: ");
   fgets(dateiname, 100, stdin);
   dateiname[ strlen(dateiname)-1 ] = '\0'; /* \n am Ende entfernen */
   if ( (fz = fopen(dateiname, "a")) == NULL) {
      fprintf(stderr, ".......An Datei `%s' koennen keine neuen Namen "
                      "angefuegt werden\n", dateiname);
      exit(2);
   }
   fprintf(stderr, "Gib deine Adressen ein (Ende mit Leerzeile fuer Name)\n");
   while (1) {
      fprintf(stderr, "Name:    ");
      fgets(name, 100, stdin);
      name[ strlen(name)-1 ] = '\0'; /* \n am Ende entfernen */
      if (strlen(name) == 0)
         break;

      fprintf(stderr, "Vorname: ");
      fgets(vorname, 100, stdin);
      vorname[ strlen(vorname)-1 ] = '\0'; /* \n am Ende entfernen */

      fprintf(stderr, "Plz:     ");
      fscanf(stdin, "%lu", &plz); getchar();

      fprintf(stderr, "Ort:     ");
      fgets(ort, 100, stdin);
      ort[ strlen(ort)-1 ] = '\0'; /* \n am Ende entfernen */

      fprintf(fz, "%s,%s,%lu,%s\n", name, vorname, plz, ort);
   }
   fclose(fz);

   /*............................................... Dateiinhalt anzeigen */
   fprintf(stderr, "\n\nInhalt der Datei `%s' anzeigen? (j/n): ", dateiname);
   antw = tolower(getchar()); getchar();
   if (antw == 'j') {
      if ( (fz = fopen(dateiname, "r")) == NULL) {
         fprintf(stderr, ".......Datei `%s' kann nicht gelesen werden\n",
                         dateiname);
         exit(2);
      }
      i = 0;
      while ( fscanf(fz, "%[^,],%[^,],%lu,%s\n", name, vorname, &plz, ort) != EOF) {
         fprintf(stdout, "%-20.20s, %-20.20s, %-7lu, %-20.20s\n",
                         name, vorname, plz, ort);
         i++;
         if (i == 23) {                  /*  Alle 23 Zeilen neue Seite */
            printf("\n.......Nchste Seite mit Return");
            getchar();
            i = 0;
         }
      }
      fclose(fz);
   }
   return(0);
}
