#include  <stdio.h>
#include  <stdlib.h>
#include  <sys/types.h>
#include  <sys/stat.h>

int  main(int argc, char *argv[])
{
   int            i;
   struct stat    attribut;

   for (i=1 ; i<argc ; i++) {
      printf("%40s = ", argv[i]);
      if (stat(argv[i], &attribut) == -1) {
         fprintf(stderr, "....stat-Fehler\n");
         exit(1);
      }
      if (attribut.st_mode & S_IFCHR)      printf("Geraetedatei\n");
      else if (attribut.st_mode & S_IFREG) printf("Regulaere Datei\n");
      else if (attribut.st_mode & S_IFDIR) printf("Directory\n");
      else   printf("Unbekannte Dateiart\n");
   }
   return(0);
}
