#include  <stdlib.h> 
#include  <stdio.h> 
#include  <unistd.h>

int  main(int argc, char *argv[]) {
   int   i;
   char  old_dirname[100], dirname[100];

   if (getcwd(old_dirname, 100) == NULL) { /* Ermitteln des Work.-Dir.-Namens */
      fprintf(stderr, "kann Namen des Working-Directorys nicht ermitteln\n");
      exit(1);
   }
   fprintf(stderr, "....Programm wurde gestartet im Directory %s\n", old_dirname);

   for (i=1; i<argc; i++) {
      if (mkdir(argv[i], 0777) < 0) {  /*----- Anlegen des entspr. Directory */
         fprintf(stderr, "kann Directory `%s' nicht anlegen\n", argv[i]);
         continue;
      }

      if (chdir(argv[i]) < 0) {       /*----- Wechseln in entspr. Directory */
         fprintf(stderr, "kann nicht in Directory `%s' wechseln\n", argv[i]);
         continue;
      }

      if (getcwd(dirname, 100) == NULL) /* Ermitteln des Working-Directory-Namens */
         fprintf(stderr, ". kann Namen des Working-Directorys nicht ermitteln\n");
      else 
         fprintf(stderr, ".....Befinde mich nun im Directory `%s'\n", dirname);

      if (chdir(old_dirname) < 0) {   /*----- Wechseln in ursprgl. Directory */
         fprintf(stderr, ". kann nicht in urspruengliches Directory"
                         " zurueckwechseln\n");
         exit(2);
      }

      if (rmdir(argv[i]) < 0) {       /*----- Loeschen des neu angelegten Directorys */
         fprintf(stderr, "kann Directory `%s' nicht loeschen\n", argv[i]);
         continue;
      }
   }
   if (getcwd(dirname, 100) == NULL) /* Ermitteln des Working-Directory-Namens */
      fprintf(stderr, "kann Namen des Working-Directorys nicht ermitteln\n");
   else 
      fprintf(stderr, ".....Befinde mich nun wieder im Directory %s\n", dirname);
   return(0);
}
