#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  <dirent.h>
#include  <sys/types.h>

int  main(int argc, char *argv[])
{
   char           dir_name[1000];
   DIR            *dir;
   struct dirent  *dir_info;

   if (argc > 2) {
      fprintf(stderr, "Es ist nur ein Argument (Directory-Name) erlaubt\n");
      exit(1);
   }
   if (argc==2)
      strcpy(dir_name, argv[1]);
   else
      strcpy(dir_name, ".");  /* working directory */
      
   if ( (dir = opendir(dir_name)) == NULL) {
      fprintf(stderr, "kann %s nicht eroeffnen", dir_name);
      exit(2);
   }
   while ( (dir_info = readdir(dir)) != NULL)
      printf("%s\n", dir_info->d_name);
      
   closedir(dir);
   return(0);
}
