#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

/*------------------------------------------------------- main -------------*/
int  main(int argc, char *argv[])
{
    char   pfadnamen[50000], *path,
           programm_name[300],
           hilf_name[500], *pfad;
    int    i;

    if (argc < 2) {
        printf("Richtiger Aufruf:  %s  <programm_name1> ....\n", argv[0]);
        exit(1);
    }
    path = getenv("PATH");   /* Holen der PATH-Liste */
    
    strcat(pfadnamen, path);

    for (i=1; i<argc; i++) {
       strcpy(programm_name, argv[i]);
       printf("--- Programm : %s\n", programm_name);
          /* Es wird immer einer Pfadname aus der Liste der PATH-Namen
           *  mit 'strtok' herausgeschnitten, und dann geprueft, ob der
           *  gesuchte Dateiname sich unter dieser Directory befindet    */
       pfad = strtok(pfadnamen, ":");
       while (pfad != NULL) {
          strcat( strcat( strcpy(hilf_name, pfad), "/"), programm_name );
          if ( !access(hilf_name, 01) )
             printf("      %s\n", hilf_name);
          pfad = strtok(NULL, ":");
       }
   }
   return(0);
}
