#include  <stdio.h>

int  main(void)
{
   const float  kmh_faktor = 3.6;

   float std,        /* Gefahrene Stunden */
         min,        /* Gefahrene Minuten */
         liter,      /* Gebrauchte Liter  */
         kilometer,  /* Gefahrene Kilometer */
         meter,      /* Gefahrene Meter (aus Kilometer umgerechnet) */
         sek,        /* Fahrtdauer in Sekunden (aus std und min berechnet) */
         v_ms,       /* Durchschnittliche Geschwindigkeit (in m/s) */
         v_kmh,      /* Durchschnittliche Geschwindigkeit (in km/h) */
         verbrauch;  /* Durchschnittlicher Benzinverbrauch (in l/100 km) */

   printf("Gefahrene Stunden: ");
   scanf("%f", &std);
   printf("Gefahrene Minuten: ");
   scanf("%f", &min);
   printf("Gefahrene Kilometer: ");
   scanf("%f", &kilometer);
   printf("Gebrauchte Liter: ");
   scanf("%f", &liter);

   sek = std*60*60+min*60;
   meter = kilometer*1000;
   v_ms = meter/sek;
   v_kmh = v_ms*kmh_faktor;
   verbrauch = liter/kilometer*100;

   printf("\n");
   printf("Durchschnittl. Geschwindigkeit: %.2f km/h (%.2f m/s)\n", v_kmh, v_ms);
   printf("Durchschnittl. Benzinverbrauch: %.2f l/100 km\n", verbrauch);
   return(0);
}
