#include <stdio.h>

int  main(void)
{
   long int stich1,   /* Elementanzahl bei 1.Stichprobe */
            stich2,   /* Elementanzahl bei 2.Stichprobe */
            markiert, /* Anzahl der bei 2.Stichprobe markierten Elemente */
            gesamt;   /* geschaetzte Gesamtanzahl der Elemente */

   printf("Die capture-recapture-Methode\n"
          "=============================\n\n"
          "Um abzuschaetzen, wie viele Elemente, die sich nicht abzaehlen\n"
          "lassen, sich in einem bestimmten abgegrenzten Raum befinden,\n"
          "wendet man die capture-recapture-Methode an.\n\n"
          "Bei dieser Methode nimmt man zuerst eine Stichprobe,\n"
          "markiert alle Elemente der Stichprobe und entlaesst diese wieder\n"
          "in den Raum. Nach einer gewissen Zeit nimmt man dann eine zweite\n"
          "Stichprobe. Anhand der Anzahl von markierten Elementen laesst\n"
          "sich dann abschaetzen, wie viele Elemente sich insgesamt in diesem\n"
          "Raum befinden.\n\n");

   printf("Anzahl der Elemente bei der 1. Stichprobe: ");
   scanf("%ld", &stich1);
   printf("Anzahl der Elemente bei der 2. Stichprobe: ");
   scanf("%ld", &stich2);
   printf("Wie viele Elemente der 2. Stichprobe hatten eine Markierung: ");
   scanf("%ld", &markiert);

   gesamt = stich1*stich2/markiert;

   printf("\n\n\n"
          "+--------------+-------------------------------+------------+\n"
          "| 1.Stichprobe | 2.Stichprobe - davon markiert | Gesamtzahl |\n"
          "+--------------+-------------------------------+------------+\n"
          "| %12ld | %12ld - %14ld | %10ld |\n"
          "+--------------+-------------------------------+------------+\n",
          stich1, stich2, markiert, gesamt);
   return(0);
}
