/**************************************/
/*      Selbst definierte Makros      */
/**************************************/

/* Die folgenden beiden Makros funktionieren nicht richtig, wenn sie mit
   einem anderen Zeichen als mit einem Buchstaben aufgerufen werden.
   Wir lernen erst spter (in der Reihe) die Konstruktionen kennen,
   die notwendig sind, um diese Makros korrekt zu definieren.
 */
#define klein(c)    (c|0x20)  /*   klein   =    Makroname          */
                              /*     c     =    formaler Parameter */
                              /*   Befehl der durch diesen Makro-  */
                              /*   aufruf ausgefuehrt wird, ist    */
                              /*   dahinter geklammert angegeben   */

#define gross(c)    (c&0xdf)

#define volumen(a,b,c)  (a*b*c)

#define flaeche(x,y)   (x*y)
