#include <stdio.h>

int  main(void)
{
   char      zeich;
   short     short_ganz;
   int       int_ganz;
   unsigned  unsigned_ganz;
   int wert;
   
   printf("------------------------------------\n");
   printf("    zeich: %d Bytes\n", sizeof(zeich));
   printf("      'x': %d Bytes\n", sizeof('x'));
   printf("zeich+'a': %d Bytes\n", sizeof(zeich+'a'));
   printf("------------------------------------\n");
   printf("   short_ganz: %d Bytes\n", sizeof(short_ganz));
   printf("          235: %d Bytes\n", sizeof(235));
   printf("         -235: %d Bytes\n", sizeof(-235));
   printf("short_ganz+12: %d Bytes\n", sizeof(short_ganz+12));
   printf("------------------------------------\n");
   printf("   int_ganz: %d Bytes\n", sizeof(int_ganz));
   printf("        235: %d Bytes\n", sizeof(235));
   printf("       -235: %d Bytes\n", sizeof(-235));
   printf("int_ganz+12: %d Bytes\n", sizeof(int_ganz+12));
   printf("------------------------------------\n");
   printf("   unsigned_ganz: %d Bytes\n", sizeof(unsigned_ganz));
   printf("             235: %d Bytes\n", sizeof(235));
   printf("unsigned_ganz+12: %d Bytes\n", sizeof(unsigned_ganz+12));
   printf("------------------------------------\n");

     /* Fuer 1000000000+2000000000 wird mit int gerechnet, da
        sowohl 1000000000 als auch 2000000000 in int passen.
        Durch Addition wird aber Zahlenbereich von
        int ueberschritten ---> falsches Ergebnis               */
   wert = (1000000000+2000000000)/2;
   printf("(1000000000+2000000000)/2 = %d\n", wert);
   printf("------------------------------------\n");

     /* Da 3000000000 nicht in int-Bereich passt, wird hier
        mit unsigned gerechnet ---> richtiges Ergebnis          */
   wert = (1000000000+3000000000)/2;
   printf("(1000000000+3000000000)/2 = %d\n", wert);
   printf("------------------------------------\n");
   return(0);
}
