#include <stdio.h>

int  main(void)
{
   unsigned char      u_char;
   unsigned int       u_int;
   unsigned long int  u_l_int;
     signed long int  s_l_int;
   int                int1, int2;
   unsigned int       u_int1, u_int2;
   unsigned long int  u_l_int1, u_l_int2;
   
   printf("========== Regel 2.1 =================================\n"
          "  unsigned ---> lngeren signed oder unsigned\n"
          "     urspruengliche Wert bleibt unveraendert.\n"
          "------------------------------------------------------\n");
   u_char = 'a';
   u_int  = 234;
   u_l_int = u_char;
   printf(" %c (unsigned char) ---> %c (unsigned long int)\n", u_char, u_l_int);
   u_l_int = u_int;
   printf(" %u (unsigned int) ---> %lu (unsigned long int)\n", u_int, u_l_int);
   s_l_int = u_char;
   printf(" %c (unsigned char) ---> %c (signed long int)\n", u_char, s_l_int);
   s_l_int = u_int;
   printf(" %d (unsigned int) ---> %d (signed long int)\n\n\n", u_int, s_l_int);

   printf("========== Regel 2.2 =================================\n"
          "  signed ---> gleichlangen oder lngeren unsigned\n"
          "     entsprechende Bitmuster wird im unsigned abgelegt,\n"
          "     wobei bei lngerem unsigned Vorzeichenbit verlaengert wird.\n"
          "------------------------------------------------------\n");
   int1     = 0xfff;
   int2     = -3;
   u_int1   = int1;
   printf(" %d (int) ---> %u (unsigned int) = 0x%x\n", int1, u_int1, u_int1);
   u_int2   = int2;
   printf(" %d (int) ---> %u (unsigned int) = 0x%x\n", int2, u_int2, u_int2);
   u_l_int1 = int1;
   printf(" %d (int) ---> %lu (unsigned long int) = 0x%lx\n", int1, u_l_int1, u_l_int1);
   u_l_int2 = int2;
   printf(" %d (int) ---> %lu (unsigned long int) = 0x%lx = %ld (long int)\n\n\n",
          int2, u_l_int2, u_l_int2, u_l_int2);
   printf("Weiter mit Return-Taste........");
   getchar();

   printf("\n");
   printf("========== Regel 2.3 =================================\n"
          "  signed/unsigned ---> krzeren signed oder unsigned\n"
          "     Fuer Fall, dass Wert zu gross fuer Zieltyp ist, gibt es\n"
          "     keine Vorschriften von ANSI C.\n"
          "     Es gilt aber meist, dass im entspr. Bitmuster die vorne\n"
          "     ueberhaengenden Bits einfach abgeschnitten werden\n"
          "------------------------------------------------------\n");
   s_l_int = -3;
   u_l_int = 0xabcdef;
   u_char  = s_l_int;
   printf(" 0x%lx = %ld (signed long int) ---> %c (unsigned char) = 0x%x\n", 
          s_l_int, s_l_int, u_char, u_char);
   u_char = u_l_int;
   printf(" 0x%lx = %lu (unsigned long int) ---> %c (unsigned char) = 0x%x\n", 
          u_l_int, u_l_int, u_char, u_char);
   u_int = s_l_int;
   printf(" 0x%lx = %ld (signed long int) ---> %u (unsigned int) = 0x%x\n", 
          s_l_int, s_l_int, u_int, u_int);
   u_int = u_l_int;
   printf(" 0x%lx = %lu (unsigned long int) ---> %u (unsigned int) = 0x%x\n\n\n", 
          u_l_int, u_l_int, u_int, u_int);
             
   printf("========== Regel 2.4 =================================\n"
          "  unsigned ---> gleichlangen signed\n"
          "     Fuer diesen Fall, wird meist einfach das Bitmuster im\n"
          "     signed-Datentyp abgespeichert, wenn ANSI C sich auch nicht\n"
          "     fuer den Fall festlegt, dass der unsigned-Wert ausserhalb\n"
          "     des signed-Wertebereichs liegt.\n"
          "------------------------------------------------------\n");
   u_int = 123;
   int1 = u_int;
   printf(" 0x%x = %u (unsigned int) ---> %d (int) = 0x%x\n",
          u_int, u_int, int1, int1);
   u_int = 50000;
   int1 = u_int;
   printf(" 0x%x = %u (unsigned int) ---> %d (int) = 0x%x\n",
          u_int, u_int, int1, int1);
   return(0);
}
