#include <stdio.h>
#include <ctype.h>
#include <time.h>

int  main(void)
{
    int  zahl,  /* Eingegebene Zahl */
         zahl1, zahl2, zahl3, /* gefundene Loesungen */
         e3, e2, e1,   /* Ziffern fuer die 1.Zahl */
         z3, z2, z1,   /* Ziffern fuer die 2.Zahl */
         d3, d2, d1,   /* Ziffern fuer die 3.Zahl */
         lsg=0, /* zaehlt die Loesungen mit */
         lsg_gefunden=0,  /* boole'sche Var: zeigt an, ob Loesung gefunden */
         alle; /* boole'sche Var: ob alle oder nur eine Loesung ausgegeben */
    clock_t start, ende;

    printf("Zahlen zu einer Summe ermitteln\n");
    printf("===============================\n\n");
    printf("Dieses Programm ermittelt zu einer vorgegebenen Zahl\n");
    printf("3 Zahlen abc, def und ghi, deren Summe gleich dieser Zahl ist:\n");
    printf("     abc\n");
    printf("     def\n");
    printf("     ghi\n");
    printf("   -----\n");
    printf("    zahl\n");
    printf("Die einzelnen Ziffern der 3 Zahlen sind dabei alle verschieden.\n");
    printf("\n\n");

    printf("Gib eine drei- oder vierstellige Zahl ein: ");
    scanf("%d", &zahl); getchar();

    while (zahl<100 || zahl>9999) {
       printf("   ...... Zahl muss drei- oder vierstellig sein.\n");
       printf("Wiederhole deine Eingabe: ");
       scanf("%d", &zahl); getchar();
    }

    printf("\nAlle Loesungen anzeigen (j/n) ? ");
    alle=toupper(getchar())=='J';

   start=clock();

   for (zahl1=100 ; zahl1<=999 ; zahl1++)
      for (zahl2=100 ; zahl2<=999 ; zahl2++)
         for (zahl3=100 ; zahl3<=999 ; zahl3++)
            if (zahl1+zahl2+zahl3==zahl) {
               e1=zahl1/100;  e2=zahl1%100/10;  e3=zahl1%10;
               z1=zahl2/100;  z2=zahl2%100/10;  z3=zahl2%10;
               d1=zahl3/100;  d2=zahl3%100/10;  d3=zahl3%10;
               if (          e1!=e2 && e1!=e3 &&
                   e1!=z1 && e1!=z2 && e1!=z3 &&
                   e1!=d1 && e1!=d2 && e1!=d3 &&
                                       e2!=e3 &&
                   e2!=z1 && e2!=z2 && e2!=z3 &&
                   e2!=d1 && e2!=d2 && e2!=d3 &&
                   e3!=z1 && e3!=z2 && e3!=z3 &&
                   e3!=d1 && e3!=d2 && e3!=d3 &&
                             z1!=z2 && z1!=z3 &&
                   z1!=d1 && z1!=d2 && z1!=d3 &&
                                       z2!=z3 &&
                   z2!=d1 && z2!=d2 && z2!=d3 &&
                   z3!=d1 && z3!=d2 && z3!=d3 &&
                             d1!=d2 && d1!=d3 &&
                                       d2!=d3) {
                  ++lsg;
                  if (alle || (!alle && !lsg_gefunden)) {
                     printf("\n%5d. Loesung:", lsg);
                     printf("%5d\n", zahl1);
                     printf("%20d\n", zahl2);
                     printf("%20d\n", zahl3);
                     printf("               -----\n");
                     printf("%20d\n", zahl);
                     lsg_gefunden=1;
                  }
               }
            }
     if (lsg_gefunden) {
        printf("\n\n----> Insgesamt %d Loesungen gefunden\n", lsg);
     } else {
        printf("\n   Zu dieser Zahl gibt es keine Loesung!\n");
     }

   ende=clock();
   printf("\n\nGebrauchte CPU-Zeit fuer dieses Programm: %6.3f Sek.\n",
          (ende-start)/(double)CLOCKS_PER_SEC);
   return(0);
}
