#include <graphics.h>
#include <time.h>
#include <stdlib.h>

#define ZUFALLSFARBE \
       farbe = rand()%(max_farbe+1);   /* Zufaellige Zeichenfarbe */ \
       setcolor(farbe);                /* setzen                  */

#define ZUFALLS_FUELLMUSTER \
       muster = rand()%MAXLINESTYLE;   /* Zufaelliges Fuellmuster */ \
       hfarbe = rand()%(max_farbe+1);  /* Zufaellige Fuellfarbe   */ \
       setfillstyle(muster,hfarbe);    /* setzen */

int  main( int argc, char *argv[] )
{
   int maxx, maxy,
       muster, lmuster,
       farbe, hfarbe,
       mittex, mittey,
       max_farbe, poly[10];

    srand(time(NULL));  /* Zufallsgenerator initialisieren */
    
    initgraph( 640, 480 );

    maxx = getmaxx();  /* Maximal moegliche Koordinaten */
    maxy = getmaxy();
    mittex = maxx/2;   /* Bildschirm-Mittelpunkt */
    mittey = maxy/2;
    max_farbe = getmaxcolor();      /* Maximale Farbennummer */

    while (1) {  /* Figur malen */
          /*------ Bildschirm-Rahmen und -Hintergrund -------------------*/
       cleardevice( BLACK );
       setlinestyle( SOLID_LINE, 1 );
       ZUFALLSFARBE; ZUFALLS_FUELLMUSTER;
       poly[0] = poly[1] = poly[3] = poly[6] = poly[8] = poly[9] = 0;
       poly[2] = poly[4] = maxx;
       poly[5] = poly[7] = maxy;
       fillpoly( 5, poly );
          /*------ Bauch ------------------------------------------------*/
       ZUFALLSFARBE; ZUFALLS_FUELLMUSTER;
       bar3d( mittex-50, mittey-50, mittex+50, mittey+50, 0 ); /* Bauch malen */
          /*------ Kopf -------------------------------------------------*/
       ZUFALLSFARBE;
       ZUFALLS_FUELLMUSTER;
       fillellipse( mittex, mittey-100, 50, 50 );   /* Kopf malen */
          /*------ Beine -------------------------------------------------*/
       ZUFALLSFARBE; ZUFALLS_FUELLMUSTER;
       bar3d( mittex-50, mittey+50, mittex-30, mittey+150, 0 ); /* Linkes Bein */
       bar3d( mittex+30, mittey+50, mittex+50, mittey+150, 0 ); /* Rechtes Bein */
          /*------ Arme --------------------------------------------------*/
       ZUFALLSFARBE; ZUFALLS_FUELLMUSTER;
       bar3d( mittex-100, mittey-50, mittex-50,  mittey-30, 0 ); /* Linker Arm */
       bar3d( mittex+50,  mittey-50, mittex+100, mittey-30, 0 ); /* Rechter Arm */
          /*------ Augen -------------------------------------------------*/
       ZUFALLSFARBE; ZUFALLS_FUELLMUSTER;
       fillellipse( mittex-20, mittey-100, 5, 5 ); /* Linkes Auge */
       fillellipse( mittex+20, mittey-100, 5, 5); /* Rechtes Auge */
          /*------ Ohren ------------------------------------------------*/
       lmuster = rand()%MAXLINESTYLE;   /* Zufaelliges Linienmuster */
       setlinestyle( lmuster, 3 );      /* und dicke Linie setzen */
       arc( mittex-50, mittey-100,  90, 270, 10 ); /* Linkes Ohr */
       arc( mittex+50, mittey-100, 270,  90, 10 ); /* Rechtes Ohr */
         /*------- Mund -------------------------------------------------*/
       arc( mittex, mittey-100, 225, 315, 30 );
          /*------ Heiligenschein ---------------------------------------*/
       ZUFALLSFARBE;
       ellipse( mittex, mittey-130, 135,45, 50,10 );
          /*------ Tisch ------------------------------------------------*/
       ZUFALLSFARBE; ZUFALLS_FUELLMUSTER;
       fillellipse( mittex+200,mittey+160, 30,10 );
       ZUFALLSFARBE; ZUFALLS_FUELLMUSTER;
       fillellipse( mittex+200,mittey+100, 10,60 );
       ZUFALLSFARBE;
       setfillstyle( SOLID_FILL, rand()%getmaxcolor() );
       fillellipse(mittex+200,mittey, 100,50 );

       if ( getch() == Key_Escape ) /* Abbruch bei ESC */
          break;
    }
    closegraph();
    return(0);
}
