#include  <stdio.h>
#include  <math.h>

/*------- dual ---------------------------------------------------------*/
void  dual(long zahl)
{
   if (zahl!=0) {
      dual(zahl/2);
      printf("%ld", zahl%2);
   }
}

/*------- primfakt -----------------------------------------------------*/
void  primfakt(long zahl)
{
   long  teiler=2, wurzel=sqrt(zahl);

   while (teiler<=wurzel) {
      if (zahl%teiler==0) {
         while (zahl%teiler==0) {
            zahl /= teiler;
            printf("%ld ", teiler);
         }
      }
      teiler++;
   }
   if (zahl>1)
      printf("%ld ", zahl);
}

/*------- alle_teiler --------------------------------------------------*/
void  alle_teiler(long zahl)
{
   long  i;

   for (i=1 ; i<=zahl ; i++)
      if (zahl%i==0)
         printf("%ld ", i);
}

/*------- ausgabe ------------------------------------------------------*/
void ausgabe(long  zahl, void (*funkzgr)(long zahl))
{
   (*funkzgr)(zahl);
}

/*------- main ---------------------------------------------------------*/
int  main(void)
{
   long   zahl;
   char   zeich;   

   printf("Gib eine ganze Zahl ein: ");
   scanf("%ld", &zahl); getchar();
   
   printf("(1) Dualdarstellung\n"
          "(2) Primfaktoren\n"
          "(3) Alle Teiler\n\n"
          "Deine Wahl: ");
   
   zeich=getchar();
   switch (zeich) {
        case '1': ausgabe(zahl, dual);        break;
        case '2': ausgabe(zahl, primfakt);    break;
        case '3': ausgabe(zahl, alle_teiler); break;
   }
   printf("\n");
   return(0);
}
