#include  <stdio.h>
#include  <math.h>
#include  <ctype.h>

#define  PI  4*atan(1)

/*--------- berech --------------------------------------------------------*/
float berech( float  rad,  float  (*welch_funktion)(float rad) ) 
{
   return(rad* (*welch_funktion)(rad));
}

/*--------- zyl_vol -------------------------------------------------------*/
float zyl_vol(float r)
{
   return(r*PI);
}

/*--------- kug_vol -------------------------------------------------------*/
float kug_vol(float r)
{
   return(r*r*4/3*PI);
}

/*--------- main ----------------------------------------------------------*/
int  main(void)
{
    float   radius,  hoehe;
    char    wahl;

    do  {
       printf("\nVolumen eines Zylinders oder einer Kugel ( Z/K ) ? ");
       wahl = toupper(getchar());
       if (wahl!='Z' && wahl!='K')  {
          printf("\n\n\nFalsche Eingabe!\n\n");
          printf("Sie duerfen nur Z oder K eingeben !\n\n");
          printf("Wiederholen Sie Ihre Eingabe !\n\n\n");
       }
    } while (wahl!='Z' && wahl!='K');

    printf("\nGeben Sie Radius ein: ");
    scanf("%f", &radius);
    
    if (wahl=='Z')  {
       printf("Geben Sie Hoehe des Zylinders ein: ");
       scanf("%f", &hoehe);
       printf("  ---> Volumen (Zylinder): %f\n", hoehe*berech(radius,zyl_vol));
    } else  
       printf("  ---> Volumen (Kugel): %f\n",berech(radius,kug_vol));
    return(0);
}
