#include  <stdio.h>
#include  <graphics.h>
#include  <stdarg.h>

/*-------------- poly_zeichnen ----------------------------------------------*/
void poly_zeichnen(int x_start, int y_start, ...)
{
   va_list  arg_zeiger;
   int      x=x_start, y=y_start;

   va_start(arg_zeiger, y_start);
   moveto(x, y);

   while (1) {
      if ( (x=va_arg(arg_zeiger, int)) < 0 || (y=va_arg(arg_zeiger, int)) < 0)
	 break;
      lineto(x, y);
   }

   va_end(arg_zeiger);
}

/*-------------- main -------------------------------------------------------*/
int  main( int argc, char *argv[] )
{
   initgraph( 640, 480 );
   settextstyle( "Times", 24 );
   outtextxy( 10, 10, getmaxx(), getmaxy(), 
              "Testprogramm fuer Funktion poly_zeichnen()\n"
              "==========================================\n\n"
              "Zwei Polygone:\n"
              "   1. Polygon: 10,10 - 100,250 - 250,50 - 20,400 - 150,70\n"
              "   2. Polygon: 300,300 - 350,200 - 250,150 - 300,300\n\n\n"
              "Weiter mit beliebiger Taste...\n");
   getch();

   cleardevice( WHITE );
   poly_zeichnen(10, 10, 100, 250, 250, 50, 20, 400, 150, 70, -1);
   poly_zeichnen(300, 300, 350, 200, 250, 150, 300, 300, -1);

   getch();
   closegraph();
   return(0);
}
