#include  <stdio.h>
#include  <stdarg.h>
#include  <ctype.h>

long double  viel_add3(char format, ...)
{
    va_list       arg_zeiger;
    long double   wert, ergeb=0;

    va_start(arg_zeiger, format);  /*--- Zugriff auf 1.Argument (noch benamt) -*/

      /*--- Lesen der restl. Argumente (unbenamt); Ende, wenn Argument = 0 --*/
    while (format != 'e') {
        switch (tolower(format)) {
           case 'c':
           case 'd':
              wert = va_arg(arg_zeiger, int); break;
           case 'l':
              wert = va_arg(arg_zeiger, long); break;
           case 'f':
              wert = va_arg(arg_zeiger, double); break;
           case 'z':
              wert = va_arg(arg_zeiger, long double); break;
        }
        ergeb += wert;
        format = va_arg(arg_zeiger, int); /*--- Naechstes Formatzeichen lesen -*/
    }

    va_end(arg_zeiger); /*--- Stack wieder in sauberen Zustand versetzen---*/

    return(ergeb);
}

int  main(void)
{
    long double sum;
    
    sum = viel_add3('d', -200, 'f', 0.5, 'c', 'x', 'l', 1000000, 'z', 1e9L, 'e');
    printf("-200 + 0.5 + 'x' + 1000000 + 1e9L = %Lf\n", sum);
    return(0);
}
