#include  <stdio.h>
#include  <ctype.h>
#include  <graphics.h>
#include  "turing.h"
#include  "fehler.h"
#include  "bildschi.h"

#define STARTPOSX   100
#define STARTPOSY   150
#define WIDTH       15
#define HEIGHT      textheight()
#define VERZOEGER   delay(200);

static int  schritt=0;
static char *eingabe;

/*------------- naechstes_zeichen ---------------------------------------*/
static boolean  naechstes_zeichen(int x, char *zeich)
{
   *zeich = toupper( eingabe[x] );

   if (erlaubtes_zeichen(*zeich))
      return(TRUE);
   else {
      fehler_meld(".... Unerlaubtes Zeichen '%c' .....\n", *zeich);
      return(FALSE);
   }
}

/*------------- einaus_init ---------------------------------------------*/
boolean einaus_init(char *erstes_zeichen)
{
   cleardevice(LIGHTBLUE);
   eingabe = gettext( "Geben Sie die Bandinschrift ein" );
   settextstyle( "Courier", 24 );
   outtextxy( STARTPOSX, STARTPOSY, getmaxx(), getmaxy(), eingabe );
   settextstyle( "Times", 24 );
   return ( naechstes_zeichen( 0, erstes_zeichen) );
}

/*------------- bildschirm_bewege_kopf ----------------------------------*/
int  bildschirm_bewege_kopf(int alt_pos, int neu_pos,
                            int ausgabezeichen, char *eingabezeichen,
                            int alt_zustand, int neu_zustand)
{
    char string[100];

    settextstyle( "Courier", 24 );
    setcolor(RED);    /* Ausgabezeichen an `altpos ausgeben */
    eingabe[alt_pos] = ausgabezeichen;
    sprintf(string, "%c", ausgabezeichen);
    setviewport( STARTPOSX+alt_pos*WIDTH,   STARTPOSY,
                 STARTPOSX+(alt_pos+1)*WIDTH, STARTPOSY+HEIGHT );
    clearviewport( LIGHTBLUE );
    outtextxy( STARTPOSX+alt_pos*WIDTH,   STARTPOSY,
               STARTPOSX+(alt_pos+1)*WIDTH, STARTPOSY+HEIGHT, string );

    setcolor( BLACK );    /* Alten Schreib-/Lesezeiger loeschen */
    sprintf(string, " ");
    setviewport( STARTPOSX+alt_pos*WIDTH,   STARTPOSY+HEIGHT,
                 STARTPOSX+(alt_pos+1)*WIDTH, STARTPOSY+2*HEIGHT );
    clearviewport( LIGHTBLUE );
    outtextxy( STARTPOSX+alt_pos*WIDTH,   STARTPOSY+HEIGHT,
               STARTPOSX+(alt_pos+1)*WIDTH, STARTPOSY+2*HEIGHT, string );

    sprintf(string, "^");   /* Neuen Schreib-/Lesezeiger setzen */
    setviewport( STARTPOSX+neu_pos*WIDTH,       STARTPOSY+HEIGHT,
                 STARTPOSX+(neu_pos+1)*WIDTH, STARTPOSY+2*HEIGHT );
    clearviewport( LIGHTBLUE );
    outtextxy( STARTPOSX+neu_pos*WIDTH,      STARTPOSY+HEIGHT,
               STARTPOSX+(neu_pos+1)*WIDTH, STARTPOSY+2*HEIGHT, string );

    sprintf(string, "%d. Schritt", ++schritt);
    outtextxy( 200, 400, getmaxx(), getmaxy(), string );

    setcolor(WHITE);
    settextjustify( HCENTER_TEXT, VCENTER_TEXT );
    setviewport( 0, getmaxy()-40, 200, getmaxy() );
    clearviewport( BLACK );
    settextstyle( "Times", 24 );
    sprintf(string, "Zustand: %d --> %d", alt_zustand, neu_zustand);
    outtextxy( 0, getmaxy()-40, 200, getmaxy(), string );
    
    VERZOEGER;

    setviewport( 0, 0, getmaxx(), getmaxy() );
    setcolor( BLACK );
    return (naechstes_zeichen(neu_pos, eingabezeichen));
}
