#include  <stdio.h>
#include  <stdlib.h>

/*------- Externe Funktionen, die hier aufgerufen werden ---------------*/
extern int  ein_ziel(void);
extern int  ein_momentan(void);

/*-------------- Makro WEG_AUSGABE -------------------------------------*/
#define  WEG_AUSGABE(erst,n,string,letzt) { \
            int i;                          \
            printf("%s", erst);             \
            for (i=0 ; i<abs(n) ; i++)      \
               printf("%s", string);        \
            printf("%s", letzt);            \
}

/*-------------- weg ---------------------------------------------------*/
static void  weg(int horizontal, int vertikal) /*-- nur in diesem Modul */
{                                              /*---- aufrufbar         */
   int   i;
   
   if ((vertikal == 0) && (horizontal == 0))
      printf("\n\n\n  ----- Ziel erreicht ----\n\n\n");

   else if (horizontal == 0)
      if (vertikal < 0)                                   /*   .     */
         WEG_AUSGABE(".\n", vertikal, "|\n", "V\n\n\n")   /*   |     */
                                                          /*   V     */
      else                                                 /*     A   */
         WEG_AUSGABE("A\n", vertikal, "|\n", ".\n\n\n")    /*     |   */
                                                           /*     .   */
   else if (vertikal == 0)
      if (horizontal < 0)
         WEG_AUSGABE("<", horizontal, "-", ".\n\n\n")   /* <----.  */
      else
         WEG_AUSGABE(".", horizontal, "-", ">\n\n\n")   /* .---->  */
 
   else if ((vertikal< 0) && (horizontal> 0)) {     /* .       */
      WEG_AUSGABE(".\n", vertikal, "|\n", " ")      /* |       */
      WEG_AUSGABE("", horizontal, "-", ">\n\n\n")   /*  -----> */

   } else if ((vertikal> 0) && (horizontal> 0)) {      /*  -----> */
      WEG_AUSGABE(" ", horizontal, "-", ">\n")         /* |       */
      WEG_AUSGABE("", vertikal, "|\n", ".\n\n\n")      /* .       */

   } else if ((vertikal< 0) && (horizontal< 0)) {   /*      .  */
      WEG_AUSGABE("", horizontal, " ", ".\n")       /*      |  */
      for (i=0 ; i>vertikal ; --i)                  /* <----   */
         WEG_AUSGABE("", horizontal, " ", "|\n")
      WEG_AUSGABE("<", horizontal, "-", "\n\n\n")

   } else if ((vertikal> 0) && (horizontal< 0)) {     /* <----   */
      WEG_AUSGABE("<", horizontal, "-", "\n")         /*      |  */
      for (i=0 ; i<vertikal ; ++i)                    /*      .  */
         WEG_AUSGABE("", horizontal, " ", "|\n")
      WEG_AUSGABE("", horizontal, " ", ".\n\n\n")
   }
}

/*-------------- main --------------------------------------------------*/
int  main(void)
{
    int  zielpunkt=ein_ziel(), momentan;

    do {
       momentan = ein_momentan();
       weg(zielpunkt%100-momentan%100, zielpunkt/100-momentan/100);
   } while ((zielpunkt-momentan) != 0);
   return(0);
}
