#include  <stdio.h>

/*------------------------------ Initialisieren von zwei int-Arrays ---------*/
int  array1[2][3] = { {1, 2, 3},
                      {4, 5, 6}};
int  array2[2][3] = { {11, 12, 13},
                      {14, 15, 16}};

/*--------------------------- Setzen von zwei Zeiger auf die Arrays ---------*/
int (*z1)[3] = array1;
int (*z2)[3] = array2;

void  ausgabe_array(char *text, int (*array)[3], int zeilnr);
void  swap_array(int (**a1)[3], int (**a2)[3]);

/*------------------------------------------------------------ main ---------*/
int  main(void)
{
   printf("------------- Vor Vertauschen -----------------\n");
   ausgabe_array("z1", z1, 2);
   ausgabe_array("z2", z2, 2);
   printf("                 Nur zum Test: z2[1][2] = %d\n\n", z2[1][2]);

   swap_array(&z1, &z2); /* Vertauschen der beiden Array-Zeiger */

   printf("------------- Nach Vertauschen -----------------\n");
   ausgabe_array("z1", z1, 2);
   ausgabe_array("z2", z2, 2);
   printf("                Nur zum Test: z1[1][0] = %d\n", z1[1][0]);
   return(0);
}

/*--------------------------------------------------- ausgabe_array ---------*/
void  ausgabe_array(char *text, int (*array)[3], int zeilnr)
{
   int  i, j;
   
   printf("%s.............\n", text);
   for (i=0; i<zeilnr; i++) {
      for (j=0; j<3; j++)
         printf("%4d", array[i][j]);
      printf("\n");
   }
}

/*------------------------------------------------------ swap_array ---------*/
void  swap_array(int (**a1)[3], int (**a2)[3])
{
   int (*h)[3];
   
   h  = *a1;
   *a1 = *a2;
   *a2 = h;
}
