#include  <stdio.h>

int  jahre[28][6] = { {0} };       /* Jahrtabelle mit Nullen initialisieren */
int  monate[28][12] = {
        {4,0,0,3,5,1,3,6,2,4,0,2},      /* Initialisieren der Monatstabelle */
        {5,1,1,4,6,2,4,0,3,5,1,3},      /* entsprechend der Vorgabe aus dem */
        {6,2,2,5,0,3,5,1,4,6,2,4},      /* Dauerkalender                    */
        {0,3,4,0,2,5,0,3,6,1,4,6},
        {2,5,5,1,3,6,1,4,0,2,5,0},
        {3,6,6,2,4,0,2,5,1,3,6,1},
        {4,0,0,3,5,1,3,6,2,4,0,2},
        {5,1,2,5,0,3,5,1,4,6,2,4},
        {0,3,3,6,1,4,6,2,5,0,3,5},
        {1,4,4,0,2,5,0,3,6,1,4,6},
        {2,5,5,1,3,6,1,4,0,2,5,0},
        {3,6,0,3,5,1,3,6,2,4,0,2},
        {5,1,1,4,6,2,4,0,3,5,1,3},
        {6,2,2,5,0,3,5,1,4,6,2,4},
        {0,3,3,6,1,4,6,2,5,0,3,5},
        {1,4,5,1,3,6,1,4,0,2,5,0},
        {3,6,6,2,4,0,2,5,1,3,6,1},
        {4,0,0,3,5,1,3,6,2,4,0,2},
        {5,1,1,4,6,2,4,0,3,5,1,3},
        {6,2,3,6,1,4,6,2,5,0,3,5},
        {1,4,4,0,2,5,0,3,6,1,4,6},
        {2,5,5,1,3,6,1,4,0,2,5,0},
        {3,6,6,2,4,0,2,5,1,3,6,1},
        {4,0,1,4,6,2,4,0,3,5,1,3},
        {6,2,2,5,0,3,5,1,4,6,2,4},
        {0,3,3,6,1,4,6,2,5,0,3,5},
        {1,4,4,0,2,5,0,3,6,1,4,6},
        {2,5,6,2,4,0,2,5,1,3,6,1}
     };

int  wochen_tage[7][7] = { {0} }; /* Wochentag-Tabelle mit 0 initialisieren */
char  tag[7][11] = {              /* zweidim. Vektor   tag   mit erster     */
         "Montag",                /* Dimension 7 (wegen 7 Wochentage) und   */
         "Dienstag",              /* zweiter Dimension 11 (weil laengster   */
         "Mittwoch",              /* Wochentag Donnerstag 10 Zeichen lang   */
         "Donnerstag",            /* + 1 Zeichen fuer das abschliessende    */
         "Freitag",               /* \0-Zeichen) mit den Wochentagen vorbe- */
         "Samstag",               /* setzen.                                */
         "Sonntag"
      };

int main(void)
{
    int  i, j, zahl,ges_tag, ges_monat, ges_jahr, zeile;
    int  mon_kennzahl, schluessel_zahl;

    for (i=1 ; i<=24 ; i++)              /* Belegen der ersten Spalte des   */
        jahre[i+3][0] = 1900+i;          /* zweidimensionalen Vektors jahre */
    for (j=1 ; j<6 ; j++)                /* Belegen der restlichen Spalten  */
        for (i=0,zahl=1925+(j-1)*28 ; i<28 ; zahl++,i++)
            jahre[i][j] = zahl;

    wochen_tage[6][0] = 1;             /* Belegen der 1. und letzten Spalte */
    wochen_tage[0][6] = 37;            /* des zweidim. Vektors wochen_tage  */

    for (j=1 ; j<6 ; j++)             /* Belegen der restlichen Spalten von */
        for (i=0,zahl=2+(j-1)*7 ; i<7 ; zahl++,i++)          /* wochen_tage */
            wochen_tage[i][j] = zahl;

    printf("Geben Sie das Datum ein: ");
    scanf("%d.%d.%d", &ges_tag, &ges_monat, &ges_jahr);

    for (j=0,i=4 ; j<6 ; )  {            /* Durchschauen der Jahrestabelle  */
        if (jahre[i][j] == ges_jahr)     /* nach eingegeb. Jahreszahl; wird */
           break;                        /* die gewuenschte Jahreszahl      */
        if (i<27)                        /* gefunden, dann wird Schleife    */
           i++;                          /* mit break verlassen.            */
        else {
           i=0;
           j++;
        }
    }

    zeile = i;        /* Merken der Zeile, in der Jahreszahl gefunden wurde */

    mon_kennzahl = monate[zeile][ges_monat-1];
    schluessel_zahl = mon_kennzahl+ges_tag;

    for (j=0,i=6 ; j<7 ; )  {
        if (wochen_tage[i][j] == schluessel_zahl)
           break;
        if (i<6)
           i++;
        else  {
           i=0;
           j++;
        }
    }

    printf("\n\n%2d.%2d.%4d ist ein %s\n", ges_tag, ges_monat, ges_jahr, tag[i]);
    return(0);
}
