#include <stdio.h>

#define  MAX_ZEILEN  20
#define  MAX_SPALTEN 20

char   rechteck [MAX_ZEILEN] [MAX_SPALTEN];
char   text[MAX_ZEILEN*MAX_SPALTEN];

/*---------- lies_text --------------------------------------------------*/
int lies_text(void)
{
    int  i=0;

    while ( (text[i++]=getchar())!='\n' && i<MAX_ZEILEN*MAX_SPALTEN)
       ;
    return(i-1);
}

/*---------- main -------------------------------------------------------*/
int  main(void)
{
    int  laenge, i, j, k, zeilen, spalten;

    printf("\nGeben Sie den zu verschluesselnden Satz ein !\n");
    laenge = lies_text();  /* In laenge wird die Laenge des eingegebenen */
                           /* Textes gespeichert                         */

        /*-------------------------------------------------------------------*/
        /* Eingabe der Zeilen- und Spaltenzahl fuer Verschluessel.-Rechteck  */
        /*-------------------------------------------------------------------*/
    do  {
       printf("\nWieviel Zeilen soll Verschluessel.-Rechteck besitzen? ");
       scanf("%d", &zeilen);

       printf("Wieviel Spalten soll Verschluessel.-Rechteck besitzen? ");
       scanf("%d", &spalten);

       if (zeilen*spalten < laenge)  {
           printf("\n .....Zu wenig Platz im Verschluessel.-Rechteck !!\n");
           printf(" .....Wiederholen Sie Ihre Eingabe !\n");
       }
    } while (zeilen*spalten < laenge);

        /*--------------------------------------------------------*/
        /* Auffuellen des Arrays text mit Leerzeichen             */
        /*--------------------------------------------------------*/
    for (i=laenge ; i<MAX_ZEILEN*MAX_SPALTEN ; i++)
       text[i] = ' ';

        /*--------------------------------------------------------*/
        /* Eintragung des Textes in das Verschluessel.-Rechteck   */
        /*--------------------------------------------------------*/
    k = 0;
    for (i=0 ; i<zeilen ; i++)
        for (j=0 ; j<spalten ; j++)
           rechteck[i][j] = text[k++];

        /*--------------------------------------------------------*/
        /* Auslesen des Textes aus Verschluessel.-Rechteck        */
        /*--------------------------------------------------------*/
    printf("\nDie verschluesselte Nachricht ist:\n");
    for (j=0 ; j<spalten ; j++)
        for (i=0 ; i<zeilen ; i++)
           printf("%c", rechteck[i][j]);
    printf("\n");
   return(0);
}
