#include  <stdio.h>
#include  <stdlib.h>
#include  <time.h>

/*--------- vergleich --------------------------------------------------*/
int  vergleich(const void *zahl1, const void *zahl2)
{
     /* void*-Argumente zuerst nach (int *)-Zeiger casten,
        und dann Zugriff auf die Werte, auf welche die so
        "gecasteten" Zeiger zeigen:
             * (int *)zahl1   und   * (int *)zahl2       */
    return(* (int *)zahl1 - * (int *)zahl2);  /* aufsteigend sortieren */
}

/*--------- main -----------------------------------------------------------*/
int  main(void)
{
   int   i, k, zahlen[10];
    
   srand(time(NULL));
  
   for (i=0 ; i<10 ; i++)
      zahlen[i] = rand()%100;

   printf("---- vor qsort-----------------------\n");
   for (k=0; k<10; k++)
      printf("%3d", zahlen[k]);
   printf("\n\n");

   qsort(&(zahlen[0]),               /* Startadresse des zu sortier. Arrays */
         sizeof(zahlen)/sizeof(int), /* Anzahl der Elemente; hier 10        */
         sizeof(int),                /* Groesse eines Array-Elements        */
         &vergleich);                /* Name der Vergleichsroutine          */

   printf("---- nach qsort----------------------\n");
   for (k=0; k<10; k++)
      printf("%3d", zahlen[k]);
   printf("\n\n");
   return(0);
} 
