#include  <stdio.h>

/*------ 1. Realisierung von strcpy mit Arrays ----------------------------*/
char *strcpy1(char ziel[], const char quelle[])
{
   int  zaehl = 0;
   
   while (quelle[zaehl]) {          /* Solange akt. Zeichen quelle[zaehl] */
      ziel[zaehl] = quelle[zaehl];  /* ungleich 0, da letztes Zeichen     */
      zaehl++;                      /* eines Strings immer \0 (=0) ist.   */
   }
   ziel[zaehl] = '\0';
   return(ziel);  /* strcpy liefert als Rueckgabewert immer den Zeiger ziel */
}

/*------ 2. Realisierung von strcpy mit Arrays ----------------------------*/
char *strcpy2(char ziel[], const char quelle[])
{
   int  zaehl = 0;
   
   while ( (ziel[zaehl] = quelle[zaehl]) )
      zaehl++;
   return(ziel);  /* strcpy liefert als Rueckgabewert immer den Zeiger ziel */
}

int  main(void)
{
   char  *gruss = "Hallo, wie gehts";
   char  gruss1[100], gruss2[100];
   
   strcpy1(gruss1, gruss);
   printf("%s\n", gruss1);
   
   strcpy2(gruss2, gruss);
   printf("%s\n", gruss2);
   
   return(0);
}
