#include  <stdio.h>
#include  <ctype.h>
#include  <string.h>
#include  <stdlib.h>

void  usage(char *progname);
static int   falsch = 0;
static char  *progname;

/*------------------------------------------------- main ------------------*/
int  main(int argc, char *argv[])
{
    int   binaer=0, oktal=0, hexa=0, zahlda=0, i;
    long  zahl, hilf;
    char  *zgr;

    progname = argv[0];

    if (argc == 1)
       usage(progname);

    while (--argc > 0) {
        if ((*++argv)[0] == '-' && argv[0][1] == '-') {
           for (zgr=argv[0]+2 ; *zgr != '\0' ; zgr++) {
              switch(tolower(*zgr)) {
                  case 'b':  binaer=1; break;
                  case 'o':  oktal=1;  break;
                  case 'h':  hexa=1;  break;
                  default:   
                     printf("....... Unerlaubte Option --%c\n", zgr[0]);
                     usage(progname);
                     break;
              }
           }
        } else {
           hilf = strtol(argv[0], &zgr, 10);
           if (strlen(zgr) > 0) {
              printf("....... Unerlaubte Zahl %s\n", argv[0]);
              usage(progname);
           } else {
              if (zahlda == 0)
                 zahl = hilf;
              zahlda++;
           }
        }
    }

    if (zahlda != 1) {
       printf("....... Es muss genau eine Zahl angegeben sein\n");
       usage(progname);
    }

    if (falsch == 0) {
       if (binaer==0 && oktal==0 && hexa==0)
          binaer = oktal = hexa = 1;
       printf("%20s: %ld\n", "Dezimal", zahl);
       if (binaer == 1) {
          printf("%20s: ", "Dual");
          for (i=sizeof(zahl)*8-1; i>=0; i--)
             printf("%ld%s", (zahl>>i) & 1, (i%8==0) ? " " : "");
          printf("\n");
       }
       if (oktal == 1)
          printf("%20s: %lo\n", "Oktal", zahl);
       if (hexa == 1)
          printf("%20s: %lx\n", "Hexadezimal", zahl);
    }

    return(falsch);
}

/*------------------------------------------------ usage ------------------*/
void  usage(char *progname)
{
    if (falsch == 0) {
       printf("usage: %s [--boh] zahl\n", progname);
       falsch = 1;
    }
}
