#include  <stdio.h>
#include  <ctype.h>

union zahl {
    float           float_zahl;
    double          double_zahl;
    struct {
       unsigned long   hexa_zahl1;
       unsigned long   hexa_zahl2;
    } long_format;
};
union zahl  z;

/*----------------------------------------------------- dual_ausgabe --------*/
void  dual_ausgabe(unsigned long zahl, int strich1, int strich2)
{
   int i;
    
   for (i=31; i>=0; i--)
      printf("%ld%s", (zahl>>i) & 1, (i==strich1 || i==strich2) ? " | " : "");
}

/*------------------------------------------------------------- main --------*/
int  main(void)
{
    int  wahl;
    
    while (1) {
       do {
          printf("f   Float-Zahl\n"
                 "d   Double-Zahl\n"
                 "e   Ende\n"
                 "      Deine Wahl: ");
          wahl = tolower(getchar());
          getchar();
       } while (wahl != 'f' && wahl != 'd' && wahl != 'e');
    
       if (wahl == 'f') {
          printf("Gib Deine Gleitpunktzahl ein: ");
          scanf("%f", &z.float_zahl); getchar();
          printf(" ......");
          dual_ausgabe(z.long_format.hexa_zahl1, 31, 23);
       } else if (wahl == 'd') {
          printf("Gib Deine Gleitpunktzahl ein: ");
          scanf("%lf", &z.double_zahl); getchar();
          printf(" ......");
          dual_ausgabe(z.long_format.hexa_zahl2, 31, 20);
          dual_ausgabe(z.long_format.hexa_zahl1, -1, -1);
       } else
          break;
       printf("\n\n");
    }
    return(0);
}
