#include  <stdio.h>
#include  <stdlib.h>

struct person {
    int            nummer;
    struct person  *naechst;
};

void  auszaehlen(int n, int z);
void  *allokiere(int groesse);

/*----------------------------------------------------- main ------------*/
int  main(void)
{
   int  n, z;

   printf("Wie viele Personen: "); 
    scanf("%d", &n);
   printf("Der wievielte soll immer ausgesondert werden: ");
    scanf("%d", &z);
   printf("In folgender Reihenfolge wird ausgesondert:\n");
   auszaehlen(n, z);

   return(0);
}

/*----------------------------------------------- auszaehlen ------------*/
void  auszaehlen(int n, int z)
{
   int            i, j=0;
   struct person  *anfang, *pers, *zgr;

         /*............ Anlegen der ringfoermig einfach verketteten Liste */
   anfang = allokiere(sizeof(struct person));
   anfang->nummer = 1;
   zgr = anfang;
   for (i=2; i<=n; i++) {
      pers = allokiere(sizeof(struct person));
      pers->nummer = i;
      zgr->naechst = pers;
      zgr = pers;
   } 
   zgr->naechst = anfang;

         /*............ Aussondern (Simulieren des Abzaehlvorgangs)       */
   do { 
      for (i=1; i<z; i++)
         zgr = zgr->naechst;
      printf("%4d,%c", zgr->naechst->nummer, (++j%14==0) ? '\n' : ' ' );
      zgr->naechst = zgr->naechst->naechst;
   } while (zgr != zgr->naechst);
   printf("%4d\n", zgr->nummer);
}

/*------------------------------------------------------- allokiere -------*/
void  *allokiere(int groesse)
{
   void  *zgr;
   
   if ( (zgr = malloc(groesse)) == NULL) {
      printf("......... Speicherplatzmangel\n");
      exit(1);
   }
   return(zgr);
}
