#include  <stdio.h>
#include  <ctype.h>

struct komplex {
    float   real_teil;
    float   imag_teil;
};

struct komplex  eingab(int nr);
struct komplex  berech(int wahl, struct komplex zahl1, struct komplex zahl2);
int             opwahl(void);

/*-------------------------------------------------------- main ----------*/
int  main(void)
{  
   struct komplex  alt_zahl, neu_zahl, ergeb;
   int             wahl, z=1;

   alt_zahl = eingab(z);
   while ( (wahl=opwahl()) != 'e') {
      neu_zahl = eingab(++z);
      ergeb = berech(wahl, alt_zahl, neu_zahl);
      printf("\n......(%g%+gi) %c (%g%+gi) = (%g%+gi)......\n\n",
              alt_zahl.real_teil, alt_zahl.imag_teil, wahl,
              neu_zahl.real_teil, neu_zahl.imag_teil,
              ergeb.real_teil, ergeb.imag_teil);
      alt_zahl = ergeb;
   }
   return(0);
}

/*------------------------------------------------------ eingab ----------*/
struct komplex  eingab(int nr)
{
   struct komplex  zahl;
   
   printf("Realteil der %d. komplexen Zahl: ", nr);
   scanf("%f", &zahl.real_teil);
   printf("Imaginaerteil der %d. komplexen Zahl: ", nr);
   scanf("%f", &zahl.imag_teil);
   getchar();
   return(zahl);
}

/*------------------------------------------------------ berech ----------*/
struct komplex  berech(int wahl, struct komplex zahl1, struct komplex zahl2)
{  
   switch (wahl) {
      case '+': zahl1.real_teil += zahl2.real_teil;
                zahl1.imag_teil += zahl2.imag_teil;
                break;
      case '-': zahl1.real_teil -= zahl2.real_teil;
                zahl1.imag_teil -= zahl2.imag_teil;
                break;
   }
   return(zahl1);
}

/*------------------------------------------------------ opwahl ----------*/
int  opwahl(void)
{
   int   operat;

   do {
      printf("Welche Operation (+,-); e=Ende: ");
      operat = tolower(getchar());
      getchar();
   } while (operat != '+' && operat != '-' && operat != 'e');
   return(operat);
} 
