#include  <stdio.h>
#include  <ctype.h>

int  array1[] = {   1,   2,   3,   4 },
     array2[] = {  10,  20,  30,  40 },
     array3[] = { 100, 200, 300, 400 };

struct stru {
    int   ganz;
    int   *komponente;
} stru_array[] = { {1}, {2}, {3} };
struct stru *stru_zgr;

void  ausgabe(char *string);

/*================================================================ main ===*/
int  main(void)
{
      /*------------------------------------------------------------*/
   stru_array[0].komponente = array1;
   stru_array[1].komponente = array2;
   stru_array[2].komponente = array3;
   stru_zgr = stru_array;
   
   ausgabe("Ganz zu Beginn");
      /*------------------------------------------------------------*/
   ++stru_zgr->ganz;        /* entspricht: ++(stru_zgr->ganz); 
                               Inhalt von ganz wird um 1 erhoeht  */
   ausgabe("nach ++stru_zgr->ganz");
      /*------------------------------------------------------------*/
   (++stru_zgr)->ganz = -1; /* zuerst stru_zgr um eine Position weitersetzen,
                               bevor entspr. ganz der Wert -1 zugewiesen wird */
   ausgabe("nach (++stru_zgr)->ganz = -1");
      /*------------------------------------------------------------*/
   stru_zgr++->ganz = -2;  /* zuerst ganz den Wert -2 zuweisen,
                              dann stru_zgr um eine Position weitersetzen. */
   ausgabe("nach stru_zgr++->ganz = -2");

      /*------------------------------------------------------------*/
   stru_zgr = stru_array;
   ausgabe("nach stru_zgr = stru_array");
      /*------------------------------------------------------------*/
   *stru_zgr->komponente = 5;   /* entspricht: *(stru_zgr->komponente) = 5; 
                                   Inhalt des int-Speicherplatzes, auf den
                                   komponente zeigt, auf 5 setzen         */
   ausgabe("nach *stru_zgr->komponente = 5");
      /*------------------------------------------------------------*/
   *stru_zgr->komponente++ = 6; /* entspricht: *((stru_zgr->komponente)++) = 6; 
                                   Inhalt des int-Speicherplatzes, auf den
                                   komponente zeigt, auf 6 setzen, und dann
                                   komponente um eine Position weitersetzen  */
   ausgabe("nach *stru_zgr->komponente++ = 6");
      /*------------------------------------------------------------*/
   (*stru_zgr->komponente)++;   /* Inhalt des int-Speicherplatzes, auf den
                                   komponente zeigt, um 1 erhoehen           */
   ausgabe("nach (*stru_zgr->komponente)++");
      /*------------------------------------------------------------*/
   (*stru_zgr++->komponente)++; /* Inhalt des int-Speicherplatzes, auf den
                                   komponente zeigt, um 1 erhoehen, dann
                                   stru_tgr um eine Position weiterpos.      */
   ausgabe("nach (*stru_zgr++->komponente)++");

   return(0);
}

/*============================================================== ausgabe ===*/
void  ausgabe(char *string)
{
   int  i, j;
   
   printf("\n---------- stru_array [%s] -------------------\n", string);
   printf("...Adressen: stru_array=%p, stru_zgr=%p\n", stru_array, stru_zgr);
   for (i=0; i<3; i++) {
      printf("....%d.... ganz: %d, komponente (%x):",
             i, stru_array[i].ganz, stru_array[i].komponente);
      for (j=0; j<3; j++)
         printf(" %3d,", stru_array[i].komponente[j]);
      printf("\n");
   }
}
