#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>

struct knoten {
         char            name[20]; /*  Name des Laeufers           */
         char            staat[10];/*  Nationalitaet  (Abkuerzung) */
         char            zeit[20]; /*  gelaufene Zeit              */
         struct knoten   *links;   /* linker Nachkomme             */
         struct knoten   *rechts;  /* rechter Nachkomme            */
};

char  name[20], staat[10], zeit[20];

struct knoten  *einordnen(struct knoten *knot_zeig);
void           drucke_baum(struct knoten *knot_zeig, int *nr);

/*---------------------------------------------------------- main -----------*/
int  main(void)
{
   struct knoten     *wurzel;
   int               i=1, platz;

   wurzel=NULL;

   while (1) {
      printf("\nName des gerade eingelaufenen Sportlers: ");
      fgets(name, 20, stdin);
      name[ strlen(name)-1 ] = '\0'; /* \n am Ende entfernen */
      if (strlen(name) == 0)
         break;
      printf("Nationalitaet des Sportlers: ");
      fgets(staat, 10, stdin);
      staat[ strlen(staat)-1 ] = '\0'; /* \n am Ende entfernen */
      printf("Gelaufene Zeit (hh/mm/ss.hh): ");
      fgets(zeit, 20, stdin);
      zeit[ strlen(zeit)-1 ] = '\0'; /* \n am Ende entfernen */
      wurzel = einordnen(wurzel);
      printf("\nZwischenstand nach %d Laeufer\n"
             "=============================\n", i++);
      printf("%12s %-15s%5s  %s\n", "Platz", "Name", "Land", "Zeit");
      platz = 1;
      drucke_baum(wurzel, &platz);
   }
   printf("\nEndergebnis:\n"
          "============\n");
   printf("%12s %-15s%5s  %s\n", "Platz", "Name", "Land", "Zeit");
   platz = 1;
   drucke_baum(wurzel, &platz);

   return(0);
}

/*----------------------------------------------------- einordnen -----------*/
struct knoten  *einordnen(struct knoten *knot_zeig)
{
    int  zeit_vergl;

    if (knot_zeig==NULL) {
       knot_zeig = (struct knoten *)malloc(sizeof(struct knoten));
       if (knot_zeig == NULL) {
          printf(".....Speicherplatzmangel...\n");
          exit(1);
       }
       strcpy(knot_zeig->name, name);
       strcpy(knot_zeig->staat, staat);
       strcpy(knot_zeig->zeit, zeit);
       knot_zeig->links = knot_zeig->rechts = NULL;
    } else if ( ( (zeit_vergl = strcmp(zeit, knot_zeig->zeit)) < 0) ||
                ( (zeit_vergl == 0) && (strcmp(name, knot_zeig->name) < 0)))
       knot_zeig->links = einordnen(knot_zeig->links);
    else
       knot_zeig->rechts = einordnen(knot_zeig->rechts);

    return(knot_zeig); 
}

/*--------------------------------------------------- drucke_baum -----------*/
void  drucke_baum(struct knoten *knot_zeig, int *nr)
{
    if (knot_zeig != NULL) {
       drucke_baum(knot_zeig->links, nr);
       printf("%10d   %-15s%5s  %s\n", (*nr)++,
              knot_zeig->name, knot_zeig->staat, knot_zeig->zeit);
       drucke_baum(knot_zeig->rechts, nr);
    }
}
