#include  <stdio.h>
#include  <math.h>

void  wurzel_ausgabe(void)
{
   int  i;
   double vier_wurzel = 2,
          neun_wurzel = 3;

   struct {
      int w0;
      int w1;
      double w[19];
   } wurzel = {
       0,
       1,
       { sqrt(2), sqrt(3), vier_wurzel, sqrt(5),  sqrt(6), sqrt(7), sqrt(8),
         neun_wurzel, sqrt(10), sqrt(11), sqrt(12), sqrt(13), sqrt(14),
         sqrt(15),    sqrt(16), sqrt(17), sqrt(18), sqrt(19), sqrt(20)
       }
   };

   printf("Wurzel von  0: %d\n", wurzel.w0 );
   printf("Wurzel von  1: %d\n", wurzel.w1 );
   for (i=0; i<=18; i++) 
      printf("Wurzel von %2d: %g\n", i+2, wurzel.w[i] );
}

int  main(void)
{
   wurzel_ausgabe();
   
   return 0;
}

