#include  <stdio.h>
#include  <string.h>

typedef enum { natronlauge, kalilauge, kalkwasser } lauge;
typedef enum { salzsaeure, schwefelsaeure, salpetersaeure, kohlensaeure } saeure;

char  *lauge_name[]  = { "Natronlauge", "Kalilauge", "Kalkwasser" };
char  *saeure_name[] = { "Salzsure",     "Schwefelsure",
                         "Salpetersure", "Kohlensure"};

void  schreibe(lauge l, saeure s);

/*---------------------------------------------------------- main --------*/
int  main(void)
{
   lauge  i;
   saeure j;   

   printf("%11s||", "");
   for (j=salzsaeure; j<=kohlensaeure; j++)
      printf("%15s |", saeure_name[j]);
   printf("\n-----------||");
   for (j=salzsaeure; j<=kohlensaeure; j++)
      printf("----------------|");
   printf("\n");

   for (i=natronlauge; i<=kalkwasser; i++) {
      printf("%11s||", lauge_name[i]);
      for (j=salzsaeure; j<=kohlensaeure; j++)
         schreibe(i, j);
      printf("\n");
   }
   return(0);
}

/*------------------------------------------------------ schreibe --------*/
void  schreibe(lauge l, saeure s)
{
   char  string[100];
   
   switch (l) {
      case natronlauge:  sprintf(string, "%s", "Natrium"); break;
      case kalilauge  :  sprintf(string, "%s", "Kalium");  break;
      case kalkwasser :  sprintf(string, "%s", "Calcium"); break;
   }
   switch (s) {
      case salzsaeure     :  strcat(string, "clorid");   break;
      case schwefelsaeure :  strcat(string, "sulfat");   break;
      case salpetersaeure :  strcat(string, "nitrat");   break;
      case kohlensaeure   :  strcat(string, "carbonat"); break;
   }
   printf("%15s |", string);
}
