#include  <stdio.h>
#include  <ctype.h>
#include  "fehler.h"

int  main(int argc, char *argv[])
{
   FILE       *fz;
   int        zeich, i, z=0;
   long int   buchst[26]={0L};

   if (argc < 2)
      fehler_meld(FATAL, "....usage:  %s datei(en)", argv[0]);
        
   for (i=1; i<argc; i++) {
      if ( (fz=fopen(argv[i], "r")) == NULL)
         fehler_meld(WARNUNG_SYS, "....kann Datei `%s' nicht zum Lesen oeffnen",
                                  argv[i]);
      else {
         while ( (zeich=fgetc(fz)) != EOF)
            if (isalpha(zeich))
               buchst[tolower(zeich)-'a']++;
         if (ferror(fz))
            fehler_meld(FATAL_SYS, "Fehler beim Lesen aus %s", argv[i]);
         z++;
         fclose(fz);
      }
   }

   for (i='a'; i<='z'; i++)
      printf("%10c | %7ld |%s", i, buchst[i-'a'], i%3==0 ? "\n" : "   ");
   printf("\n\n");
   
   fehler_meld(WARNUNG, "....Es wurden %d von %d Dateien ausgewertet", z, argc-1);

   return(0);
}
