#include  <stdio.h>
#include  <string.h>
#include  <stdlib.h>
#include  <ctype.h>

struct person {
   char           name[100], vorname[100], ort[100];
   unsigned long  plz;
};

int  main(void)
{
   FILE           *fz;                     /* Zeiger auf FILE-Struktur  */
   char           dateiname[100];              /*  Dateiname            */
   int            i, antw;                            /* Hilfsvariablen */
   struct person  adr;

   fprintf(stderr, "In welche Datei (evtl. mit Pfad) "
		   "sollen Namen angehaengt werden: ");
   fgets(dateiname, 100, stdin);
   dateiname[ strlen(dateiname)-1 ] = '\0'; /* \n am Ende entfernen */
   if ( (fz = fopen(dateiname, "a")) == NULL) {
      fprintf(stderr, ".......An Datei `%s' koennen keine neuen Namen "
		      "angefuegt werden\n", dateiname);
      exit(2);
   }
   fprintf(stderr, "Gib deine Adressen ein (Ende mit Leerzeile fuer Name)\n");
   while (1) {
      fprintf(stderr, "Name:    ");
      fgets(adr.name, 100, stdin);
      adr.name[ strlen(adr.name)-1 ] = '\0'; /* \n am Ende entfernen */
      if (strlen(adr.name) == 0)
	 break;

      fprintf(stderr, "Vorname: ");
      fgets(adr.vorname, 100, stdin);
      adr.vorname[ strlen(adr.vorname)-1 ] = '\0'; /* \n am Ende entfernen */

      fprintf(stderr, "Plz:     ");
      fscanf(stdin, "%lu", &adr.plz); getchar();

      fprintf(stderr, "Ort:     ");
      fgets(adr.ort, 100, stdin);
      adr.ort[ strlen(adr.ort)-1 ] = '\0'; /* \n am Ende entfernen */

      if (fwrite(&adr, sizeof(struct person), 1, fz) != 1) {
	 fprintf(stderr, "....Fehler beim Schreiben in Datei `%s'\n", dateiname);
	 exit(1);
      }
   }
   fclose(fz);

   /*............................................... Dateiinhalt anzeigen */
   fprintf(stderr, "\n\nInhalt der Datei `%s' anzeigen? (j/n): ", dateiname);
   antw = tolower(getchar()); getchar();
   if (antw == 'j') {
      if ( (fz = fopen(dateiname, "r")) == NULL) {
         fprintf(stderr, ".......Datei `%s' kann nicht gelesen werden\n",
                         dateiname);
         exit(2);
      }
      i = 0;
      while ( fread(&adr, sizeof(struct person), 1, fz) == 1) {
         fprintf(stdout, "%-20.20s, %-20.20s, %-7lu, %-20.20s\n",
                         adr.name, adr.vorname, adr.plz, adr.ort);
         i++;
         if (i == 23) {                  /*  Alle 23 Zeilen neue Seite */
            printf("\n.......Nchste Seite mit Return");
            getchar();
            i = 0;
         }
      }
      if (ferror(fz)) {
         fprintf(stderr, "....Fehler beim Lesen aus Datei `%s'\n", dateiname);
         exit(1);
      }
      fclose(fz);
   }
   return(0);
}
