#include  <stdio.h>
#include  <stdlib.h>

#define MAX_ZEILLAENG   200

int  main(int argc, char *argv[])
{
   FILE    *fz;
   char    zeile[MAX_ZEILLAENG];
   int     zeilnr=0;
      
   if (argc != 2) {
      fprintf(stderr, "usage: %s dateiname\n", argv[0]);
      exit(1);
   }
   if ( (fz=fopen(argv[1], "r")) == NULL) {
      fprintf(stderr, "....kann Datei `%s' nicht oeffnen", argv[1]);
      exit(2);
   }
   while (fgets(zeile, MAX_ZEILLAENG, fz) != NULL)
      fprintf(stdout, "%5d %s", ++zeilnr, zeile);

   if (ferror(fz)) {
      fprintf(stderr, "....Fehler beim Lesen aus Datei `%s'", argv[1]);
      exit(3);
   }
      
   fclose(fz);

   return(0);
}   
