#include  <sys/sysmacros.h> /* fuer Makros minor/minor; in BSD: <sys/types.h> */
#include  <sys/stat.h>
#include  <stdio.h>
#include  <stdlib.h>

int  main(int argc, char *argv[])
{
   struct stat      statpuff;
   int              i;

   for (i=1 ; i<argc ; i++) {
      printf("%20s: ", argv[i]);

      if (stat(argv[i], &statpuff) < 0)
         fprintf(stderr, "Fehler bei lstat (%s)\n", argv[i]);
      else {
         printf("dev = %2d/%2d", major(statpuff.st_dev), minor(statpuff.st_dev));
         if (S_ISCHR(statpuff.st_mode) || S_ISBLK(statpuff.st_mode) ) {
            printf("; rdev = %2d/%2d (%s", 
                      major(statpuff.st_rdev), minor(statpuff.st_rdev),
                      (S_ISCHR(statpuff.st_mode)) ? "zeichen" : "block");
            printf("orient.)");
         }
      }
      printf("\n");
   }
   return(0);
}
