#include  <stdio.h>
#include  <string.h>
#include  <unistd.h>

char *neu_env[]  = { "TERM=vt100", "VISUAL=emacs", "TEMP=/usr/tmp", NULL };
char *neu_argv[] = { "arg_env", "Hallo", "schoene", "Welt", NULL };

int  main(int argc, char *argv[])
{
   char *pfad = "/suse/herold/c_buch/src/kap33/arg_env"; /* entspr. anpassen */

   if (argc != 2) {
      fprintf(stderr, "usage: %s [execl|execv|execle|execve|execlp|execvp]\n", argv[0]);
      return(1);
   }
   printf("....execdemo %s....\n", argv[1]);
   if (!strcmp(argv[1], "execl")) {
      if (execl(pfad, "arg_env", "Hallo", "schoene", "Welt", NULL) < 0)
         fprintf(stderr, "....execl-Fehler\n");

   } else if (!strcmp(argv[1], "execv")) {
      if (execv(pfad, neu_argv) < 0)
         fprintf(stderr, "....execv-Fehler\n");

   } else if (!strcmp(argv[1], "execle")) {
      if (execle(pfad, "arg_env", "Hallo", "schoene", "Welt", NULL, neu_env) < 0)
         fprintf(stderr, "....execle-Fehler\n");

   } else if (!strcmp(argv[1], "execve")) {
      if (execve(pfad, neu_argv, neu_env) < 0)
         fprintf(stderr, "....execve-Fehler\n");

   } else if (!strcmp(argv[1], "execlp")) {
      if (execlp("arg_env", "arg_env", "Hallo", "schoene", "Welt", NULL) < 0)
         fprintf(stderr, "....execlp-Fehler\n");

   } else if (!strcmp(argv[1], "execvp")) {
      if (execvp("arg_env", neu_argv) < 0)
         fprintf(stderr, "....execvp-Fehler\n");
   } else {
      fprintf(stderr, "usage: %s [execl|execv|execle|execve|execlp|execvp]\n", argv[0]);
      return(1);
   }

   return(0);
}
