#include  <stdio.h> 
#include  <dirent.h>
#include  <stdlib.h> 
#include  <string.h>
#include  <sys/types.h>
#include  <unistd.h>

 /**************************************************************/
 /*   Nachfolgenden Pfad entspr. ndern                        */
 /**************************************************************/
char *pfad = "/suse/herold/c_buch/src/kap33/meincd"; /* entspr. anpassen */

int  main(int argc, char *argv[])
{
   char  dir_name[1000], new_dirname[1000], name[1000];
   
   if (argc == 1)              /*----- Setzen von dir_name entspr. argv */
      strcpy(dir_name, ".");
   else if (argc == 2)
      strcpy(dir_name, argv[1]);
   else {
      fprintf(stderr, "....usage: %s  [directory]\n", argv[0]);
      exit(1);
   }
   if (chdir(dir_name) < 0)         /*----- Wechseln in entspr. Directory */
      fprintf(stderr, "\n.... kann nicht in Directory `%s' wechseln\n\n", dir_name);

   if (getcwd(new_dirname, 1000) == NULL) { /* Ermitteln des Work.-Dir.-Namens */
      fprintf(stderr, ".... kann Namen des Work.-Dir. nicht ermitteln\n");
      exit(2);
   }
   if (system(NULL) == 0) {  /*------ Pruefen, ob system-Aufruf moeglich ist */
      fprintf(stderr, "....kein Kommandoprozessor fuer system-Aufruf vorh.\n");
      exit(3);
   }

   printf("_____%s_____\n", new_dirname);  /*----- Ausgeben des Dir.-Inhalts */

   system("ls -aCF | more");
   printf("\n.....In welches Directory wollen Sie wechseln: ");
   fgets(name, 1000, stdin);
   name[ strlen(name)-1 ] = '\0'; /* \n am Ende entfernen */
   if (strlen(name)==0)
      return(0);
   if (execl(pfad, "meincd", name, NULL) < 0) {
      fprintf(stderr, "....execl-Fehler");
      perror("");
      exit(4);
   }
   return(0);
}
