#include  <stdio.h>
#include  <stdlib.h>
#include  <signal.h>

static void  strgc_faenger(int sig);

/*-------- main --------------------------------------------------------*/
int  main(void)
{
    if (signal(SIGINT, strgc_faenger) == SIG_ERR) {
       fprintf(stderr, ".....Signalhandler 'strgc_faenger' konnte "
                       "nicht installiert werden");
       exit(1);
    }
    fprintf(stderr, ".....Signalhandler  strgc_faenger  installiert....\n");

       /* Warte-Schleife */
    while (1)
       ;

    fprintf(stderr, "---- Programmende ---\n");
    return(0);
}

/*-------- Signalhandler-Routinen ----------------------------------*/
void  strgc_faenger( int sig )   /*--------------- strgc_faenger ---*/
{
   static int i=1;
      /* Fuer die Dauer dieser Funktionsausfuehrung muessen weitere  */
      /* SIGINT-Signale ignoriert werden.                            */
    signal(SIGINT, SIG_IGN);

    fprintf(stderr, "   %d. Strg-c gedrueckt", i);

    if (i<=3) {
       if (signal(SIGINT, strgc_faenger) == SIG_ERR) {
          fprintf(stderr, ".....Signalhandler 'strgc_faenger' konnte "
                          "nicht installiert werden");
          exit(1);
       }
       fprintf(stderr, "\n");
    } else {
       fprintf(stderr, " (Programmende)\n");
       exit(0);
    }
    i++;
}
