#include  <stdio.h>
#include  <ctype.h>
#include  <complex.h>

complex  eingab(int nr);
void     ausgab1(char *funk, complex zahl, complex erg);
void     ausgab2(int op, complex z1, complex z2, complex erg);
complex double cquad(complex double a);

/*-------------------------------------------------------- main ----------*/
int  main(void)
{  
   complex  zahl1, zahl2, erg;
   double   nerg;

   zahl1 = eingab(1);
   zahl2 = eingab(2);

   printf("\n");
   nerg = carg(zahl1);
   printf("......Phasenwinkel(%g%+gi) = %g\n",
           creal(zahl1), cimag(zahl1), nerg );
   nerg = conj(zahl1);
   printf("......komplex konjugiert(%g%+gi) = %g\n",
           creal(zahl1), cimag(zahl1), nerg );
   printf("\n");
   erg = zahl1+zahl2;       ausgab2('+', zahl1, zahl2, erg );
   erg = zahl1-zahl2;       ausgab2('-', zahl1, zahl2, erg );
   erg = zahl1*zahl2;       ausgab2('*', zahl1, zahl2, erg );
   erg = zahl1/zahl2;       ausgab2('/', zahl1, zahl2, erg );
   erg = cpow(zahl1,zahl2); ausgab2('^', zahl1, zahl2, erg );
   printf("\n");
   erg = cabs(zahl1);   ausgab1("cabs", zahl1, erg );
   erg = cacos(zahl1);  ausgab1("cacos", zahl1, erg );
   erg = cacosh(zahl1); ausgab1("cacosh", zahl1, erg );
   erg = casin(zahl1);  ausgab1("casin", zahl1, erg );
   erg = casinh(zahl1); ausgab1("casinh", zahl1, erg );
   erg = catan(zahl1);  ausgab1("catan", zahl1, erg );
   erg = catanh(zahl1); ausgab1("catanh", zahl1, erg );
   erg = ccos(zahl1);   ausgab1("ccos", zahl1, erg );
   erg = ccosh(zahl1);  ausgab1("ccosh", zahl1, erg );
   erg = cexp(zahl1);   ausgab1("cexp", zahl1, erg );
   erg = clog(zahl1);   ausgab1("clog", zahl1, erg );
   erg = cproj(zahl1);  ausgab1("riemannsche Sphaere", zahl1, erg );
   erg = csin(zahl1);   ausgab1("csin", zahl1, erg );
   erg = csinh(zahl1);  ausgab1("csinh", zahl1, erg );
   erg = csqrt(zahl1);  ausgab1("csqrt", zahl1, erg );
   erg = ctan(zahl1);   ausgab1("ctan", zahl1, erg );
   erg = ctanh(zahl1);  ausgab1("ctanh", zahl1, erg );
   printf("\n");
   erg = cquad(zahl1);  ausgab1("cquad", zahl1, erg );

   return 0;
}

/*------------------------------------------------------ eingab ----------*/
complex  eingab(int nr)
{
   double   real, imag;
 
   printf("Realteil der %d. komplexen Zahl: ", nr);
   scanf("%lf", &real);
   printf("Imaginaerteil der %d. komplexen Zahl: ", nr);
   scanf("%lf", &imag);
   getchar();
   return(real+imag*I);
}

/*----------------------------------------------------- ausgab1 ----------*/
void  ausgab1(char *funk, complex zahl, complex erg)
{
    printf("......%s(%g%+gi) = (%g%+gi)\n",
            funk, creal(zahl), cimag(zahl), creal(erg), cimag(erg));
}

/*----------------------------------------------------- ausgab2 ----------*/
void  ausgab2(int op, complex z1, complex z2, complex erg)
{
    printf("......(%g%+gi) %c (%g%+gi) = (%g%+gi)\n",
            creal(z1), cimag(z1), op, creal(z2), cimag(z2),
            creal(erg), cimag(erg));
}

/*------------------------------------------------------- cquad ----------*/
complex double cquad(complex double a) {
   return (a * a);
}
