#include <stdio.h>
#include <stdint.h>

#define PRNT4(n,a,b,c,d) \
    printf("| %15s | %5d | %5d | %5d | %5d |\n", n, \
           sizeof(a) * 8, sizeof(b) * 8, sizeof(c) * 8, sizeof(d) * 8);

int main(void)
{
   printf("| %15s | %5s | %5s | %5s | %5s |\n", " ",
          "N=8", "N=16", "N=32", "N=64");
   printf("|-----------------+-------+-------+-------+-------|\n");
   PRNT4("intN_t", int8_t, int16_t, int32_t, int64_t);
   PRNT4("uintN_t", uint8_t, uint16_t, uint32_t, uint64_t);
   PRNT4("int_leastN_t", int_least8_t, int_least16_t,
                         int_least32_t, int_least64_t);
   PRNT4("uint_leastN_t", uint_least8_t, uint_least16_t,
                          uint_least32_t, uint_least64_t);
   PRNT4("int_fastN_t", int_fast8_t, int_fast16_t,
                        int_fast32_t, int_fast64_t);
   PRNT4("uint_fastN_t", uint_fast8_t, uint_fast16_t,
                         uint_fast32_t, uint_fast64_t);
   PRNT4("INTN_C", INT8_C(123344353535), INT16_C(5), INT32_C(5), INT64_C(5));
   PRNT4("INTN_C", INT8_C(5), INT16_C(5), INT32_C(5), INT64_C(5));
   PRNT4("UINTN_C", UINT8_C(9223353535), UINT16_C(5), UINT32_C(5), UINT64_C(5));
   PRNT4("UINTN_C", UINT8_C(5), UINT16_C(5LL), UINT32_C(5), UINT64_C(5));
   PRNT4("INTMAX_C", INTMAX_C(3535), INTMAX_C(0), INTMAX_C(445), INTMAX_C(0xaf));
   PRNT4("UINTMAX_C", UINTMAX_C(5), UINTMAX_C(-1), UINTMAX_C(335), UINTMAX_C(-2));
   printf("\n");

   printf("intptr_t = %d, uintptr_t = %d\n",
          sizeof(intptr_t)*8, sizeof(uintptr_t)*8);
   printf("intmax_t = %d, uintmax_t = %d\n",
          sizeof(intmax_t)*8, sizeof(uintmax_t)*8);

   return 0;
}

