#include <stdio.h>
#include <math.h>

int  main(void)
{
   double  a, b, c, d,
           vorkomma, nachkomma,
           mantisse;
   int  exponent;
   
   printf("Gib 4 Gleitpunktzahlen durch Komma getrennt ein: ");
   scanf("%lf,%lf,%lf,%lf", &a, &b, &c, &d);
   
   printf("\nceil(%.4lf) = %.4lf\n", a, ceil(a));
   printf("ceil(%.4lf) = %.4lf\n", b, ceil(b));
   printf("ceil(%.4lf) = %.4lf\n", c, ceil(c));
   printf("ceil(%.4lf) = %.4lf\n", d, ceil(d));

   printf("\nfloor(%.4lf) = %.4lf\n", a, floor(a));
   printf("floor(%.4lf) = %.4lf\n", b, floor(b));
   printf("floor(%.4lf) = %.4lf\n", c, floor(c));
   printf("floor(%.4lf) = %.4lf\n", d, floor(d));

   printf("\nfabs(%.4lf) = %.4lf\n", a, fabs(a));
   printf("fabs(%.4lf) = %.4lf\n", b, fabs(b));
   printf("fabs(%.4lf) = %.4lf\n", c, fabs(c));
   printf("fabs(%.4lf) = %.4lf\n", d, fabs(d));

   printf("\nfmod(%.4lf,%.4lf) = %.4lf\n", b, a, fmod(b,a));
   printf("fmod(%.4lf,%.4lf) = %.4lf\n", d, c, fmod(d,c));

   printf("\n\nWeiter mit Return......");
   getchar(); getchar();
   
   printf("\nmodf:\n");
   nachkomma=modf(a, &vorkomma);
   printf("%.4lf = %.0lf + %.4lf\n", a, vorkomma, nachkomma);
   nachkomma=modf(b, &vorkomma);
   printf("%.4lf = %.0lf + %.4lf\n", b, vorkomma, nachkomma);
   nachkomma=modf(c, &vorkomma);
   printf("%.4lf = %.0lf + %.4lf\n", c, vorkomma, nachkomma);
   nachkomma=modf(d, &vorkomma);
   printf("%.4lf = %.0lf + %.4lf\n", d, vorkomma, nachkomma);

   printf("\nfrexp / ldexp:\n");
   mantisse=frexp(a, &exponent);
   printf("%.4lf = %.4lf * 2 hoch %d (frexp); ", a, mantisse, exponent);
   printf("%.4lf * 2 hoch %d = %.4lf (ldexp)\n", 
           mantisse, exponent, ldexp(mantisse, exponent));
   mantisse=frexp(b, &exponent);
   printf("%.4lf = %.4lf * 2 hoch %d (frexp); ", b, mantisse, exponent);
   printf("%.4lf * 2 hoch %d = %.4lf (ldexp)\n", 
           mantisse, exponent, ldexp(mantisse, exponent));
   mantisse=frexp(c, &exponent);
   printf("%.4lf = %.4lf * 2 hoch %d (frexp); ", c, mantisse, exponent);
   printf("%.4lf * 2 hoch %d = %.4lf (ldexp)\n", 
           mantisse, exponent, ldexp(mantisse, exponent));
   mantisse=frexp(d, &exponent);
   printf("%.4lf = %.4lf * 2 hoch %d (frexp); ", d, mantisse, exponent);
   printf("%.4lf * 2 hoch %d = %.4lf (ldexp)\n", 
           mantisse, exponent, ldexp(mantisse, exponent));
   return(0);
}
